#
# program to detect crosstalk between adjacent devices
# broadcast level 190, cool/warm
# turn switch off, check fw version, get height, read Vled R,L 
# loop from 0-63 to get on/off/level and dali type
#

import RPi.GPIO as GPIO
import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=2,
)

fastser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)

def SetBank(Bank,Add):
	ser.write('hC3%02X\n'%Bank) # 
	ncrlf(33)
	ser.write('hA3%02X\n'%Add) # 
	ncrlf(35)

def SetBank1(Bank,Add):
	global bus
	ser.write('%dhC3%02X\n'%(bus,Bank)) # 
	ncrlf(40)
	ser.write('%dhA3%02X\n'%(bus,Add)) # 
	ncrlf(42)

def GetLedLR(device) :
	global Left
	global Right
	SetBank(5,44)
	Right = ReadByte(0xC5,device)
	if(Right == -1):
		Left=0
		Right=0
	else:
		Left = ReadByte(0xC5,device)
		if(Left == -1):
			Left=0
			Right = 0
		if(Left > 16):
			ser.write('hA32D\n') # 45,
			x=ser.read(2)
			Left = ReadByte(0xC5,device)
	return



def GetLedLR1(device) :
	global bus
	global Left
	global Right
	SetBank1(5,44)
	Right = ReadByte1(0xC5,device)
	if(Right == -1):
		Left=0
		Right=0
	else:
		Left = ReadByte1(0xC5,device)
		if(Left == -1):
			Left = 0
			Right=0
		if(Left > 16):
			ser.write('%dhA32D\n'%bus) # 45,
			b=ser.read(1)
			x=ser.read(2)
			Left = ReadByte1(0xC5,device)
	return



def GetLedLRVolt(device) :
	global LeftVolts
	global RightVolts

	SetBank(5,56)	
	RightVolts=ReadByte(0xC5,device)  # LSB
	RightVolts=RightVolts + ReadByte(0xC5,device)*256  # MSB
	LeftVolts=ReadByte(0xC5,device)  # LSB
	LeftVolts=LeftVolts + ReadByte(0xC5,device)*256  # MSB
	return


def GetLedLRVolt1(device) :
	global LeftVolts
	global RightVolts
	SetBank1(5,56)	
	RightVolts=ReadByte1(0xC5,device)  # LSB
	RightVolts=RightVolts + ReadByte1(0xC5,device)*256  # MSB
	LeftVolts=ReadByte1(0xC5,device)  # LSB
	LeftVolts=LeftVolts + ReadByte1(0xC5,device)*256  # MSB
	return

def ncrlf(line):
	x = serchannel()
	if( x == 'N'):
		ser.read(1)  # crlf
		return
	if( x == 'H'):
		ser.read(5)  # crlf
		return
	print('L %d err %s'%(line,x)),
	if( x != '\n'):
		x=ser.read(10)
		print('L.2 %d %s'%(line,x))
	return


def crlf():
	x = ser.read(1)
	if( x != '\n'):
		print('L 116 err %s'%x),
		x=ser.read(10)
		print('L118 %s'%x)
	return

def ReadByte(cmd, dadd):
	time.sleep(.1)
	ser.write('h%02X%02X\n'%(dadd*2+1,cmd)) 
	x=fastser.read(1)
	while(x == 'H'):  # dump other traffic
		ser.read(4)  # data
		crlf()
		x=ser.read(1)  # next packet.
	if(x == 'J'):
		byte = int(ser.read(2),16)
		crlf()
		return byte
	if(x == 'X'):
		xt=ser.read(1)  # type
		print('\nCollision type %s at %d cmd= %d'%(xt,dadd,cmd))
		crlf()
		return(-1)
	if(x != 'N'):
		print('sync %s %s'%(x,cmd))
	crlf()
	return -1

def ReadByte1(cmd, dadd):
	global bus

	time.sleep(.1)
	ser.write('%dh%02X%02X\n'%(bus,dadd*2+1,cmd)) 
	b=ser.read(1)
	x=ser.read(1)
	while(x == 'H'):  # dump other traffic
		ser.read(5)  # data + crlf
		x=ser.read(1)  # next packet.
	if(x == 'J'):
		byte = int(ser.read(2),16)
		crlf()
		return byte
	if(x == 'X'):
		xt=ser.read(1)  # type
		print('\nCollision type %s at %d cmd= %d'%(xt,dadd,cmd))
		crlf()
		return(-1)
	if(x != 'N'):
		print('sync bus %d b-resp %s x=%s cmd=%s'%(bus,b,x,cmd))
	crlf()
	return -1


def serchannel():
	global bus
	global cbus
	x = ser.read(1)
	bus = 0
	cbus = 1
	if x == '1' :
		bus = 1
		cbus = 3
		x=ser.read(1)
	if x == '2' :
		bus = 2
		cbus = 3
		x=ser.read(1)
	if x == '3' :
		bus = 3
		cbus = 3
		x=ser.read(1)
	return x

def SetCCT(msbcolor,lsbcolor,address):
	address = address * 2 + 1
	ser.write('h%02x03\n'%(address)) # no fade
	ncrlf(200)
	ser.write('hC3%02X\n'%(msbcolor))
	ncrlf(202)
	ser.write('hA3%02X\n'%(lsbcolor))
	ncrlf(204)
	ser.write('hC108\n')
	ncrlf(306)
	ser.write('h%02XE7\n'%(address))
	ncrlf(208)
	ser.write('hC108\n')
	ncrlf(210)
	ser.write('t%02xE2\n'%(address))
	ncrlf(212)
	ncrlf(213)

def SetCCT1(msbcolor,lsbcolor,address):
	global bus
	address = address * 2 + 1
	ser.write('%dh%02x03\n'%(bus,address)) # no fade
	ser.write('%dhC3%02X\n'%(bus,msbcolor))
	ser.read(3)
	ser.write('%dhA3%02X\n'%(bus,lsbcolor))
	ser.read(3)
	ser.write('%dhC108\n'%bus)
	ser.read(3)
	ser.write('%dh%02XE7\n'%(bus,address))
	ser.read(3)
	ser.write('%dhC108\n'%bus)
	ser.read(3)
	ser.write('%dt%02xE2\n'%(bus,address))
	ser.read(5)
	crlf()


def SetBus():
	global bus

	i=0
	cbus = bus + 1
	print('Scan DALI bus %d'%cbus)
	if(bus > 0):
		ser.write('%dd\n'%bus)  # now check if Power is good
	else:
		ser.write('d\n')  # now check if Power is good
	x=serchannel()
	if x == 'D' :
		x=ser.read(1)
		y=int(x,16)
		if y == 2 :
			print('DALI BUS: power is good\n')
		if y == 0 :
			print('DALI BUS: power is lost\n')
		if y == 1 :
			print('DALI BUS: power is stuck high')
		if y != 2 :
			i = 64
		x=ser.read(1) # number
		crlf()
	else :
		i = 64
	return i



x=fastser.read(1000)
print('clear buff 1 %s'%x)

print('\n      ATX LED Consultants Inc - find Address, Turn Switch off, Read Vled / Height \n')

ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print(' Serial Port conflict \n')
	exit()

x=ser.read(2)
print('HW version: %s'%(x))
y=ser.read(2)
fwv = int(y,10)
print('FW version: %s'%(y))
hattype=0
y=ser.read(2)
if y != "\n" :
	hattype=int(y,10)
	print('Hat Type: %s'%(y))


if hattype == 2 :
	print('AL-DALI-Hat: 2 Channel Isolated no power')
elif hattype == 4 :
	print('AL-DALI-Hat: 4 Channel Isolated no power')

else :
	print('AL-DALI-Hat: %d'%hwtype)

CCT = 0

source = 64
dest = 64
start = 0
level = 165

if len(sys.argv) > 1 :

       if(int(text,10) > 63 ):
               CCT = 1
       if(int(text,10) & 63 > 0 ):
               start = int(text,10)&63


x=fastser.read(1000)
print('clear buff 2 %s'%x)

ser.write('q\n')
x = ser.read(1)
if(x != 'N'):
	x = ser.read(1)
	v = ser.read(5)
	i1 = ser.read(3)
	i2 = ser.read(4)
	i3 = ser.read(3)
	print('\n DALI Bus voltage = %s  Currents %s %s %s'%(v,i1,i2,i3))
	crlf() 

ser.read(100)

while CCT< 2 :

	x=fastser.read(1000)
	print('clear buff 3 %s'%x)

	counts = 1
	bus = 0
	i=SetBus()

	if(start > 0) :
		i = start

	if(dest < 64) :
		i = dest

	print('\nBus Seq SA        mV       Height Side'),

	ser.write('hFF21\n') # save in DTR
	ncrlf(354)
	ser.write('hFF4F\n') # save as scene 15
	ncrlf(356)
	ser.write('hFF03\n') # fast bcst disable fade
	ncrlf(358)

	if(source > 63 ):
		ser.write('hFE%02X\n'%level) # level
		ncrlf(361)
	else:
		ser.write('h%02X%02X\n'%(source*2,level)) # level 
		ncrlf(364)

	if(CCT):
		SetCCT(0,0,127)
		print(' test cool')
	else:
		SetCCT(1,96,127)
		print(' test warm')

	time.sleep(2)

	while ( i< 64 ):

		a = ( i * 2 ) + 1

		HW_Version = ReadByte(0xA6,i) # model
		if(HW_Version != 1):  # next
			i = i + 1
			continue

		ser.write('h%02x00\n'%(a)) # off
		ncrlf(386)
		ser.write('hFF03\n') # no fade, must do after since one shot only works with non-zero ARC
		ncrlf(388)

		SetBank(0,9) # FW
		FW_Version=ReadByte(0xC5,i)  #
		if(FW_Version == -1):  # next
			print('Add %d wrong fw'%i)
			i = i + 1
			continue

		status = ReadByte(0x90,i)	# wait for memory update
		loop = 0
		if(FW_Version < 44 ):
			mask = 0xB0
		else:
			mask = 0x10
		while((status & mask ) and loop < 6 ) :
			if(loop > 0 ):
				print(' FW %d not ready addr %d,  %02X'%(FW_Version,i,status))
			time.sleep(1)
			status = ReadByte(0x90,i)	# wait for memory update
			loop = loop + 1


		time.sleep(.5)
		GetLedLR(i)  # Height
#		print(' %d %d'%(Left,Right))
		GetLedLR(i)  # Height
		time.sleep(2)
		GetLedLRVolt(i)  # volts

		aa = level
		RL = 0
		LL = 0
		while ( aa < 186 and source < 64 ) :
			ser.write('h%02x03\n'%(source*2+1)) # no fade
			print(' %d '%aa )
			ncrlf(424)
			ser.write('h%02x%02X\n'%(source*2,aa)) # 17 slew 
			ncrlf(426)
			time.sleep(1)
			GetLedLRVolt(i)
			if(RightVolts > RL ):
				print('\n  1 %02d, %02d  has %d mVolts Crosstalk into %02d LEDs on Right'%(aa, i, RightVolts, Right))
				RL = RightVolts
			if(LeftVolts > LL ):
				print('\n  1 %02d, %02d  has %d mVolts Crosstalk into %02d LEDs on Left'%(aa, i, LeftVolts, Left))
				LL = LeftVolts
			aa = aa + 1

		if(source == 64):
			time.sleep(1)
			GetLedLRVolt(i)

		if(Left > 0):
			if((LeftVolts / Left) > 1700 ):  # on
				print('\n  1 %02d, %02d  has %d mVolts Crosstalk into %02d LEDs on Left'%(counts, i, LeftVolts, Left))

		if(Right > 0):
			if((RightVolts / Right) > 1700 ):  # on
				print('\n  1 %02d, %02d  has %d mVolts Crosstalk into %02d LEDs on Right'%(counts, i, RightVolts, Right))

		ser.write('h%02xC0\n'%(i*2)) # back on
		ncrlf(462)

		i = i+1
		counts = counts + 1

		if(dest < 64 ) :
			i = 64

	ser.write('hFF1F\n') # scene 15 recall
	ncrlf(468)

	if(hattype > 1 ):
		x=fastser.read(1000)
		print('clear buff 4 %s'%x)
		bus = 1
		i=SetBus()

	if ( ( hattype == 2 or hattype == 4 ) and i != 64) :

		ser.write('1hFF03\n') # fast
		ncrlf(479)
		ser.write('1hFE%02X\n'%(level)) # level = 192
		ncrlf(481)

		if(CCT):
			SetCCT1(0,0,127)
		else:
			SetCCT1(1,96,127)

		while ( i< 64):

			a = ( i * 2 ) + 1

			HW_Version = ReadByte1(0xA6,i) # model
			if(HW_Version != 1):  # next
				i = i + 1
				continue

			ser.write('1h%02x03\n'%(a)) # no fade
			ncrlf(498)
			ser.write('1h%02x00\n'%(a-1)) # off
			ncrlf(500)

			SetBank1(0,9) # FW
			FW_Version=ReadByte1(0xC5,i)  #
			if(FW_Version == -1):  # next
				i = i + 1
				continue

			time.sleep(.25)
			status = ReadByte1(0x90,i)	# wait for memory update
			loop = 0
			if(FW_Version < 44 ):
				mask = 0xB0
			else:
				mask = 0x10

			while((status & mask ) and loop < 30 ) :
				if(loop > 0 ):
					print(' fw %d not ready addr %d,  %02X'%(FW_Version,i,status))
				time.sleep(1)
				status = ReadByte1(0x90,i)	# wait for memory update
				loop = loop + 1


			time.sleep(1)
			GetLedLR1(i)  # Height
			GetLedLRVolt1(i)  # volts

			if(Left > 0):
				if(LeftVolts / Left > 1700 ):  # on
					print('\n  2 %02d, %02d  has %d mVolts Crosstalk into %02d LEDs on Left'%(counts, i, LeftVolts, Left))

			if(Right > 0):
				if(RightVolts / Right > 1700 ):  # on
					print('\n  2 %02d, %02d  has %d mVolts Crosstalk into %02d LEDs on Right'%(counts, i, RightVolts, Right))


			ser.write('1h%02xC0\n'%(i*2)) # back on
			ncrlf(538)

			i = i+1
			counts = counts + 1

		ser.write('1hFE00\n') # level = 0
		ncrlf(544)


	if ( hattype == 4 ) :

		x=fastser.read(1000)
		print('clear buff 5 %s'%x)

		bus=2
		i=SetBus()


		ser.write('2hFF03\n') # fast
		ncrlf(557)
		ser.write('2hFE%02X\n'%(level)) # level = 192
		ncrlf(559)

		if(CCT):
			SetCCT1(0,0,127)
		else:
			SetCCT1(1,96,127)


		while ( i< 64):
			a = ( i * 2 ) + 1
			ser.write('2h%02x90\n'%(a))
			status=ser.read(1)
			t=i
			if x=='2' :
				x=ser.read(1)
				t=300+i;
             		if x == 'J' :
				x=ser.read(2)
				y=int(x,16)
				x=ser.read(1)
				ser.write('2h%02xA6\n'%(a))
				x=ser.read(2)
				if( x == "2J"):
					z=ser.read(2)
				x=ser.read(1)
				ser.write('2h%02x99\n'%(a))
				x=ser.read(2)
				dt="  "
				if( x == "2J"):
					dt=ser.read(2)
				x=ser.read(1)
				print('address %2d is Model %s Type %s'%(t,z,dt))
				if(status & 1  == 1 ) :
					print('left OK'),
				if(status & 2 == 2 ) :
					print('right OK'),
				print('')
			else :
				if x=='D' :
					ser.write('2d\n')  # now reset power
					i=64
					X = ser.read(10)
					print('D %s'%(x)),
				if x=='N' :
					ser.read(1)
				if x!='N' :
					print('T %s'%(x)),
					y=ser.read(10)
					print('d %s'%(y))

			i = i+1
			counts = counts + 1

		ser.write('2hFE00\n') # level = 0
		ncrlf(613)


	if ( hattype == 4 ) :

		x=fastser.read(1000)
		print('clear buff 6 %s'%x)

		bus=3
		i=SetBus()

		while ( i< 64):
			a = ( i * 2 ) + 1
			ser.write('3h%02xA0\n'%(a))
			x=ser.read(1)
			t=i
			if x=='3' :
				x=ser.read(1)
				t=400+i;
             		if x == 'J' :
				x=ser.read(2)
				y=int(x,16)
				x=ser.read(1)
				ser.write('3h%02xA6\n'%(a))
				x=ser.read(2)
				z="  "
				if( x == "3J"):
					z=ser.read(2)
				x=ser.read(1)
				ser.write('3h%02x99\n'%(a))
				x=ser.read(2)
				dt="  "
				if( x == "3J"):
					dt=ser.read(2)
				x=ser.read(1)
				print('address %2d is Model %s Type %s level %3d'%(t,z,dt,y))
			else :
				if x=='D' :
					ser.write('3d\n')  # now reset power
					i=64
					X = ser.read(10)
					print('D %s'%(x)),
				if x=='N' :
					ser.read(1)
				if x!='N' :
					print('T %s'%(x)),
					y=ser.read(10)
					print('d %s'%(y))

			i = i+1
			counts = counts + 1

		ser.write('3hFE00\n') # level = 0
		ncrlf(666)


	CCT = CCT + 1

print('done')

