#
# program to read the info about all devices on a DALI bus
# loop from 0-63 to get on/off/level and dali type
#

import RPi.GPIO as GPIO
import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.2,
)

bus = ''
cbus = 1

def SetBank(DTR1, DTR):
	global bus
	global index
	ser.write('%shC3%02X\n'%(bus,DTR1))
	x=ser.read(3)
	ser.write('%shA3%02X\n'%(bus,DTR))
	x=ser.read(3)
	index = DTR
	return


def GetLedLR(device) :
	global Left
	global Right
	global Fixttl
	SetBank(5,44)
	Left = ReadByte(0xC5,device)

	if(Left == -1):
		Left=0
		Right=0
	else:
		Right = ReadByte(0xC5,device)

		if(Right == -1):
			Right = 0
		if(Right > 16):
			SetBank(5,45)
			Right = ReadByte(0xC5,device)
		
	return

def GetLedLRCCT(device) :
	global LeftCCT
	global RightCCT
	SetBank(5,10)

	Left=ReadByte(0xC5,device)
	if(Left == -1):
		LeftCCT = 0
		RightCCT = 0
	else:
		LeftCCT = Left*13 + 2700
		Right = ReadByte(0xC5,device)
		if(Right == -1):
			RightCCT = 0
		else:
			RightCCT = Right*13 + 2700
	LeftCCT = ((LeftCCT+50)/100) * 100
	RightCCT = ((RightCCT+50)/100) * 100

	return Mode

def crlf():
	x = ser.read(1)
	if( x != '\n'):
		x=ser.read(10)
		print('err %s'%x)
	return

def ReadByte(cmd, dadd):
	global bus
	time.sleep(.1)
	ser.write('%sh%02X%02X\n'%(bus,dadd*2+1,cmd)) 
	x=ser.read(1)
	if(x == '1'):
		x=ser.read(1)

	while(x == 'H'):  # dump other traffic
		ser.read(5)  # data + crlf
		x=ser.read(1)  # next packet.
	if(x == 'J'):
		byte = int(ser.read(2),16)
		crlf = ser.read(1)
		return byte
	if(x == 'X'):
		xt=ser.read(1)  # type
		print('\nCollision type %s at %d cmd= %d'%(xt,dadd,cmd))
		crlf=ser.read(1)
		return(-1)
	if(x != 'N'):
		print('sync %s %s'%(x,cmd))
	crlf=ser.read(1)
	return -1


def serchannel():
	global bus
	global cbus
	x = ser.read(1)
	bus = 1
	cbus = 2
	if x == '1' :
		bus = '1'
		cbus = 3
		x=ser.read(1)
	if x == '2' :
		bus = '2'
		cbus = 3
		x=ser.read(1)
	if x == '3' :
		bus = '3'
		cbus = 4
		x=ser.read(1)
	return x


x=ser.read(1000)

print('\n      ATX LED Consultants Inc - find Address, DALI Low drive, LED status \n')

ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print(' Serial Port conflict \n')
	exit()

x=ser.read(2)
print('HW version: %s'%(x))
y=ser.read(2)
fwv = int(y,10)
print('FW version: %s'%(y))
hattype=0
y=ser.read(2)
if y != "\n" :
	hattype=int(y,10)
	print('Hat Type: %s'%(y))


if hattype == 2 :
	print('AL-DALI-Hat: 2 Channel Isolated no power')
elif hattype == 4 :
	print('AL-DALI-Hat: 4 Channel Isolated no power')

else :
	print('AL-DALI-Hat: %d'%hattype )

z=1
lasti=0
counts=1

if len(sys.argv) > 1 :
	text = sys.argv[1]
	if(text == "1"):
		ser.write("q1\n") # set 80 mA
		ser.read(18)
		time.sleep(1)
	if(text == "3"):
		ser.write("q3\n") # set 180 mA
		ser.read(18)
		time.sleep(1)
else:
	print(' no CLI request to change current')
ser.write('q\n')
x=ser.read(1)
while(x!='Q' and x != ''):
	x=ser.read(1)
x = ser.read(1)
v = ser.read(5)
i1 = ser.read(3)
i2 = ser.read(4)
i3 = ser.read(3)

Fixttl = 0

crlf()

print('\n DALI Bus Mode = %s'%x)
print('\n DALI Bus voltage = %s  Currents %s %s %s'%(v,i1,i2,i3))


while z==1:
	ser.read(100)
	ser.write('p\n')  # now check if Power is good
	x=ser.read(1)
	print('\n Start a scan ')

	if x == 'P' :
		x=ser.read(2)
		if x != "00" :
			y = ser.read(1)
			print(' Vin A = %s.%s Volts'%(x,y)),
			x=ser.read(2)
			y = ser.read(1)
			print(' Vin B = %s.%s Volts'%(x,y)),
		else :
			x=ser.read(4)

		x=ser.read(1)
		if x == '1' :
			print('     Switch is ON\n')
		if x == '0' :
			print('     Switch is OFF\n')
		x=ser.read(1)
	i=0
	print('Scan DALI bus %s'%bus)
	ser.write('%sd\n'%bus)  # now check if Power is good
	x=ser.read(1)
	if(x == '1'):
		x=ser.read(1)

	while(x != 'D'):
		x=ser.read(1)

	if x == 'D' :
		x=ser.read(1)
		y=int(x,16)
		if(fwv == 32):
			y = 2
		if y == 2 :
			print('DALI BUS: power is good\n')
		if y == 0 :
			print('DALI BUS: power is lost\n')
		if y == 1 :
			print('DALI BUS: power is stuck high')
		if y != 2 :
			i = 64
		x=ser.read(2)

	x=ser.read(100)
	print('%s'%x)

	lasti = -1

	print('\nSeq SA Model Type DriveLow  Left     Right')


	while ( i< 64 ):

		a = ( i * 2 ) + 1
		ser.write('%sh%02x90\n'%(bus,a)) # status
		x=ser.read(1)
		if( x == '1'):
			x=ser.read(1)

		if x == 'X' :
			data=ser.read(1)
			print('Collision type %s address %d, bus %s cmd=144 '%(data,i,bus)),
			crlf()
			i = i+1
			continue
		if x == 'H' :
			data=ser.read(4)
			print('%s:H%s'%(bus,data)),
			x=ser.read(1)
			continue
		if x == 'D' :
			ser.write('d\n')  # now reset power
			ser.read(10)
			i=64
			x = 'N'
			continue
		if x == 'N' :
			crlf()
			Passive = ReadByte(171,i) # passive 
			if (Passive >= 0):
				lasti = i
				if(type > 0) :
					zerov = ""
					if (hattype & 1 ) > 0:
						if fwv > 7 :
							ser.write('u\n')  # write uxx where XX is the address 0-64
							x=ser.read(6)  # u00000 throw away
							zerov = ser.read(4)
							x=ser.read(4)  # 0000 throw away
							crlf()
				print('\n   address %2d has a hidden at level %d %s' % ( i,Passive,zerov )),
			Passive = ReadByte(172,i) # owner of passive
			if (Passive >= 0):
				print(' %2d is owner' %Passive ),
			i = i+1
			continue
		if x == 'J' :
			lasti = i-1
			x=ser.read(2)
			status=int(x,16)
			crlf()
			LampValid = ""
			if(status & 0x20):
				status = 3
				LampValid = "untested"

			model = ReadByte(166,i)
			if(model == -1):
				model = ReadByte(166,i)

			type = ReadByte(153,i)
			if(type > 0) :
				zerov = ""
				if (hattype &1 ) > 0  :
					if fwv > 7 :
						ser.write('u\n')  # write uxx where XX is the address 0-64
						x=ser.read(6)  # u00000 throw away
						zerov = ser.read(4)
						x=ser.read(4)  # 0000 throw away
						crlf() # \n
						print('\n%2d  %2d   %2d  %2d    %s mV'%(counts, i,model,type,zerov)),
				else :
						print('\n%2d  %2d   %2d  %2d         '%(counts, i,model,type)),

			if(model == 1):
				GetLedLR(i)
				Mode = 0

				if(Left == Right and Left != 0 and (status & 1) == 1):
					SetBank(5,9)
					Mode=ReadByte(0xC5,i)  # Driver Mode
					if( Mode != 3 ):
						print('%2d (%2d)  %2d (%2d)   Fixed '%(Left/3,Left,Left/3,Left)),
						Fixttl = Fixttl + Left + Left
					else:
						GetLedLRCCT(i)
						print('%2d (%2d)  %2d (%2d)   CCT %4d Left / %4d Right'%(Left/3,Left,Left/3,Left,LeftCCT,RightCCT)),
						Fixttl = Fixttl + Left
				else:
					placehold = "        "
					Fixttl = Fixttl + Left + Right

					if( Mode != 6 and Mode != 2) :
						if(status & 1  == 1 ) :
							print('%2d (%2d) '%(Left/3,Left)),
						else :
							print('%s'%placehold),

						if(status & 2 == 2 ) :
							print('%2d (%2d) '%(Right/3,Right)),
						else:
							print('%s'%placehold),
						if(status & 3 > 0):
							print(' Fixed'),
					if( Mode == 2 ):
						if(status & 1  == 1 ) :
							print('%2d (%2d) '%(Left/3,Left)),
						else :
							print('%s'%placehold),
						print(' FAN'),
					if( Mode == 2 ):
						if(status & 1  == 1 ) :
							print('%2d (%2d) '%(Left/3,Left)),
						else :
							print('%s'%placehold),
						print(' 12v'),

				print(" %s"%LampValid),

			Passive = ReadByte(171,i)
			if (Passive != -1):
				if i != (lasti+1) :
					print('\nSkipped Address'),
				print('\n   address %s%2d also has a hidden at level %d : ' % (bus,i,Passive )),
			Passive = ReadByte(172,i)
			if (Passive != -1):
				print(' %2d is owner ' %Passive),
			lasti = i
			counts = counts + 1
		i = i+1

		if( hattype == 2 and i== 64 and bus == '' ) :
			i = 0
			bus = '1'
		if( hattype == 4 and i == 64 and bus == '1' ) :
			i = 0
			bus = '2'
		if( hattype == 4 and i == 64 and bus == '2' ) :
			i = 0
			bus = '3'
		if( i == 0 ) :
			print('')


	z=0

print("\ntotal = %d"%Fixttl)

