#
# program to test each address 100 times 
#

import RPi.GPIO as GPIO
import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.25,
)

bus = 1

retchar =1

def serchannel():
	global bus
	x = ser.read(1)
	bus = 1
	if x == '1' :
		bus = 2
		x=ser.read(1)
	if x == '2' :
		bus = 3
		x=ser.read(1)
	if x == '3' :
		bus = 4
		x=ser.read(1)
	return x

def RetchF():
	global retchar
	if(retchar) :
		print('\n'),
		retchar=0
	return

x=ser.read(1000)

last=0

print('\n      ATX LED Consultants Inc - Fixture Status 100x \n')

ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print('  Serial Port Conflict  \n')
	exit()

x=ser.read(2)
print('HW version: %s'%(x))
y=ser.read(2)
fwv = int(y,10)
print('FW version: %s'%(y))
hwtype=0
y=ser.read(2)
if y != "\n" :
	hwtype=int(y,10)

if hwtype == 2 :
	print('AL-DALI-Hat: 2 Channel Isolated no power')
elif hwtype == 4 :
	print('AL-DALI-Hat: 4 Channel Isolated no power')
else :
	print('AL-DALI-Hat: %d'%hwtype )

address = 0
if(len(sys.argv) > 1) :
	address = int(sys.argv[1])

while ( address < 64 ):

	a = ( address * 2 ) + 1
	loop = 0
	errors = 0
	sense = 0
	while(loop < 10 and sense < 4) :
		ser.reset_input_buffer()
		ser.write('h%02x90\n'%(a))
		x=ser.read(1)
		if x == 'H' :
			data=ser.read(5)
			print('other bus data %s:H%s'%(bus,data)),
			retchar=1
		if x == 'N' :
			errors += 1 # no response
			sense += 1
			crlf = ser.read(1)
			x=ser.read(3) # delayed J response?
			crlf = ser.read(1)
			if(x != ""):
				RetchF()
				print('%d delayed response %s '%(address,x)),
				retchar=1
			loop += 1
		if x == 'J' :
			sense = 0
			loop += 1
			x=ser.read(2) # level
			if(loop == 1) :
				last = int(x,16) # save level
			else :
				new = int(x,16)
				if(last != new) : 
					if errors ==0 :
						print ''
					print('%x'%new),
					last = new
					errors = errors + 1
			x=ser.read(1)
	if(sense != 4) : # not dead 

		if(errors == 0):
			print ('%d OK'%address),
			retchar = 1
		else :
#			RetchF()
			print('Address %d Fail = %d '%(address,errors))
	address += 1
	if( address % 10 == 0) :
		RetchF()

print('\n done \n')
