#
#
# Program to modify the features of the ATX LED IO16, Relay or 8B devices
# See their data sheets
#
#

import time
import serial
import sys

rbus = 0

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)

global Caddress
global ModeNow

def Read( expected, String ):
	x=ser.read(1)

	rbus = 1
	y=0

	if x == '1' :
		rbus = 2
		x=ser.read(1)
	if x == '2' :
		rbus = 3
		x=ser.read(1)
	if x == '3' :
		rbus = 4
		x=ser.read(1)

	while x != 'J':
		if x == 'N':
			if( expected > 0) :
				print('            bus %d No Answer to %s'%(rbus,String))
			else :
				x= ser.read(1)
				return 999
		elif x == 'H' :
			ser.read(5)
		elif x == "" :
			return x
		else :
			print('err 1 %s %s'%(x,String) )
			x=ser.read(100)
			print('err 100 %s %s'%(x,String) )
			return 999
		x=ser.read(1)

	if x == 'J' :
		y=ser.read(2)
		y=int(y,16)
		if(expected < 2):
			if( rbus > 1 ):
				print('              %s %02X on bus %d '%(String,y,rbus))
			else :
				print('              %s %02X '%(String,y))
		x=ser.read(1)

	return y

def ParseMode(Mode, btn, addr):

	print('Mode %02X hex\n    '%Mode),
	if(Mode & 1 ) :
		print('Single Address %d'%addr),
	if(Mode & 2 ) :
		print('Group %d'%addr),
	if(Mode & 4 ) :
		print('Scene %d recall'%(addr&15)),
		if(addr & 16 ) :
			print('+ undo '),

	if(Mode & 8 ) :
		print('Broadcast '),
	if(Mode & 16 ) :
		print('Paired with button %d'%btn),
	if(( Mode & 96 ) == 0) :
		print('\nLED Off')
	if(( Mode & 96 ) == 32) :
		print('\nLED tracks Destination')
	if(( Mode & 96 ) == 64) :
		print('\nLED set by Master')
	if(( Mode & 96 ) == 96) :
		print('\nLED On/Off only')
	if(( Mode & 140) ==  128 ) : # no group, no scene
		if(Mode & 16 ) :
			if(btn & 1) :
				print('     Button sets Off/Dim Down')
			else:
				print('     Button sets On/Dim Up')
		else :
			print('     Button toggles On/Off/Dim')

def ReadAdd(bus, bank, register, dadd) :
	ser.write('%shC3%02x\n'%(bus,bank))  # set DTR1
	Read(0,"DTR")
	ser.write('%shA3%02X\n'%(bus,register))  # set DTR
	Read(0,"DTR")

	ser.write('%sh%02XC5\n'%(bus,dadd))  # read address
	response = Read(2,"Address")
	return response


def ReadMode( bus, madd, dadd) :
	global ModeNow
	global Caddress

	ser.write('%shC300\n'%(bus))  # set DTR1
	Read(0,"DTR1")
	ser.write('%shA3%02X\n'%(bus,madd))  # set DTR
	Read(0,"DTR")

	ser.write('%sh%02XC5\n'%(bus,dadd))  # read mode
	ModeNow = Read(2,"Mode")

	ser.write('%sh%02XC5\n'%(bus,dadd))  # read address sequential 
	Caddress = Read(2,"Mode")

	print('\n     button %d Mode %x Destination'%((madd-19)/2,ModeNow)),
	print('%d \n    '%Caddress),

def Write(bus, SAddress, Bank, BAddress, Data) :
	cbus =2 # read 2 characters

	if(bus != ""):
		cbus = 3

	ser.write('%shC3%02X\n'%(bus,Bank))  # set DTR1
	ser.read(cbus)
	ser.write('%shA3%02X\n'%(bus,BAddress))  # set DTR
	ser.read(cbus)
	ser.write('%st%02X81\n'%(bus,SAddress))  # enable write
	ser.read(2*cbus)
	ser.write('%shC7%02X\n'%(bus,Data))  # write mode byte

#	print(' SA %d, Bank %d, Add %d, Data %d'%(SAddress,Bank,BAddress,Data))

	Read(1,"Write")  # reads result
	time.sleep(.25)


bus = ""
dbus = 0
input = raw_input("input Bus # [1-4] ")  # enter 1 
if input == "2" :
	bus ="1"
	dbus = 1
if input == "3" :
	bus ="2"
	dbus = 2
if input == "4" :
	bus ="3"
	dbus = 3
	
x = ""

ModeNow =0

while 1 :
	if (x =="" ) :
		address=1000
		while(address > 63):
			address = raw_input("input AL-WS-8B, IO16 Address (q, dd) : ")  # enter decimal
			if(address == 'q') :
				exit()
			address = int(address,10)
		bfcn = 'n'
		dadd = address * 2 + 1

		ser.read(1000)
		ser.write('%sh%02XA6\n'%(bus,dadd))  # ping 
		there = Read(0,"HW Type")
		if( there == 10) :
			print(' AL-WS-8B found at address %d'%address)
		elif( there == 11) :
			print(' AL-IO16 found at address %d'%address)
		elif( there == 12) :
			print(' AL-Relay8 found at address %d'%address)
		else:
			print(' No multi device at this address %d'%address)
			continue;

		FW = ReadAdd(bus,0,9,dadd)
		print(' Firmware %d'%FW)
		

		ButtonM1 = 0
		while(ButtonM1 < 8):
			Group0 = ReadAdd(bus,5,12 + ButtonM1 * 8,dadd)
			Group1 = ReadAdd(bus,5,13 + ButtonM1 * 8,dadd)
			SubSAG = ReadAdd(bus,5,15 + ButtonM1 * 8,dadd)

			if(SubSAG != 255 ):
				if(SubSAG < 128 ) :
					print('     Btn %d = Address Scene %d'%(ButtonM1+1,SubSAG/2))
				else :
					print('     Btn %d = Groud Scene %d'%(ButtonM1+1,SubSAG/2-64))

			binary = format(Group0 + Group1*256,'#016b')

			if(Group0 + Group1 > 0 ):
				print('Btn %d = Groups %s'%(ButtonM1+1,binary))

			ButtonM1 = ButtonM1 + 1


		buttons = ReadAdd(bus,0,16,dadd)
		if(buttons > 0 and buttons < 9):
			print('with %d buttons'%buttons)
		else :
			print('with no buttons yet, press a button and retry')

		ButtonNum = 0
		while (bfcn == 'n') :

			while (ButtonNum < 1 or ButtonNum > 8 and ButtonNum != 8 ) :
				ButtonNum = raw_input("input button to work on\n    (1-8, 0 = Prompt, r = reset, q = quit): ")  #
				if(ButtonNum == 'q') :
					exit()
				if(ButtonNum == ''):
					ButtonNum = 8
					bfcn = 0
					continue
				if(ButtonNum == 'r') :
					Write(bus, dadd, 0, 16, 0)   # reset to 0 buttons
					ser.write('%st%02X20\n'%(bus,dadd))  # send reset
					Read(0,"Reset")
					time.sleep(5) 
					ser.write('%shA3%02X\n'%(bus,255))  # set DTR to 255
					Read(0,"DTR")
					ser.write('%sh%02X80\n'%(bus,dadd))  # set Addr to 255
					Read(0,"Addr")
					exit()

				ButtonNum = int(ButtonNum,10)

				if(ButtonNum == 0):
					Write(bus, dadd, 0, 16, 0)   # reset to 0 buttons
					print 'press last button '
					time.sleep(5) 

					buttons = ReadAdd(bus,0,16,dadd)
					if(buttons > 0 and buttons < 9):
						print('with %d buttons'%buttons)
					ButtonNum = buttons

			if(ButtonNum > buttons ):
				Write(bus, dadd, 0, 16, ButtonNum)  # set new count

			madd = ButtonNum * 2 + 19 # 21 - 35
			sadd = ButtonNum + 36 # 37-44

			pairbtn = ((ButtonNum - 1)^1 ) +1
			ser.read(1000)
			ButtonM1 = ButtonNum -1
			PB_Mode = ReadAdd(bus,5, 8 + ButtonM1 * 8,dadd)
			SubSAG  = ReadAdd(bus,5,15 + ButtonM1 * 8,dadd)

			print(' pb mode %d'%PB_Mode)

			ReadMode(bus, madd, dadd)
			ParseMode(ModeNow,pairbtn,Caddress)
			if(SubSAG != 255 ):
				if(SubSAG < 64):
					print('     Scene SA %d'%(SubSAG/2))
				else:
					print('     Scene Group %d'%((SubSAG-64)/2))

			print("\n Hex Mode = E1(SA) E2(G) E4(S) E8(B)")
			bfcn = raw_input("Enter new HEX mode for button %d, e = emulate, n = next(e, n, q, XX) : "%ButtonNum)  #
			if( bfcn == "q" ) :
				exit()
			if( bfcn == "e" ) :
				ser.write('%sh%02X4%d\n'%(bus,dadd,ButtonNum-1))  # trigger button
				print('%sh%02X4%d\n'%(bus,dadd,ButtonNum-1))  # trigger button
				time.sleep(3)  # allow bus reads
				ser.read(1000)
				bfcn = 'n'
				continue

			if( bfcn == 'n' ) :
				ButtonNum = ButtonNum + 1
				continue
				

			if( bfcn != "") :
				ModeNow = int(bfcn,16) # get new mode to set

			if( ModeNow & 4 ) : # scene

				baddress = raw_input("input Scene (decimal) : ")  
				if(baddress == "") :
					baddress = Caddress
				else :
					baddress = int(baddress,10)

				undo = raw_input("enable undo? (y): ")  
				if( undo == 'y') :
					baddress = baddress + 16


				NewSAG = raw_input("input dest address or nul : ") 
				if(NewSAG !="" ):
					SubSAG = int(NewSAG,10) * 2 + 1

					group = raw_input("is this a group? (y): ")  
					if( group == 'y') :
						SubSAG = SubSAG & 31 + 128

				else :
					SubSAG = 255
				

			else:

				baddress = raw_input("input dest address (decimal) : ")  #
				if(baddress == "") :
					baddress = Caddress
				else :
					baddress = int(baddress,10)

			print('\nSet button %d to '%baddress),
			ParseMode(ModeNow,pairbtn, baddress)
			print('\n')

			bfcn = raw_input("program? (y,n) : ")  #
			if(bfcn == 'y'):
				ser.read(1000)

				Write(bus,dadd,0,madd,ModeNow)

				Write(bus,dadd,0,madd+1,baddress)

				Write(bus,dadd,0,sadd,SubSAG)

				ReadMode(bus, madd, dadd)
				print('\n')
				bfcn = 'n'

	while x == 'H' :
		x=ser.read(4)
		print('bus data H%s on %d '%(x,rbus))
		x=ser.read(1)
		x=ser.read(1)
		if x == '1' :
			rbus = 4
			x=ser.read(1)
		if x == '2' :
			rbus = 4
			x=ser.read(1)
		if x == '3' :
			rbus = 4
			x=ser.read(1)
	if x == 'N' :
		print('no response')

	if x == 'X' :
		print('Framing Error')
		x=ser.read(10)
		print('                      Error X %s'%(x))
		x=ser.read(10)

	if x == 'Z' :
		print('Collision')
		x=ser.read(10)
		print('                      Error Z %s'%(x))
	if x == 'P' :
		print('Power Change')
		x=ser.read(10)
		print('                      Power Change %s'%(x))
	if x == 'Q' :
		print('Dali Change')
		x=ser.read(100)
		print('                      DALI Change %s'%(x))

	x = Read(0,"Loop")
