# This program pulses one address on/off at a fade rate


import time
import serial
import sys

ProgTimes = [ 0, 7, 10, 14, 20, 28, 40, 56, 80, 113, 160, 226, 320, 452, 640, 900 ]


ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)

text = input("Which DALI address 0-63, 127=all : ")
address = int(text)*2+1

text = input("What Max Level : ")
level = 200
if(text != ""):
	level = int(text)


if address < 64 :
	ser.write('h%02xA5\n'%(address))   # read current setting
	x=ser.read(1)
	if x == 'J' :
		text=ser.read(2)
		down = int(text,16)&15
		Down = ProgTimes[down]/10

		up = int(text,16)/16
		Up = ProgTimes[up]/10

		print('Address %d is set to %d Up and %d Down seconds'% (address/2,Up,Down) )
		text=ser.read(1)
	if x == 'N' :
		print(' No device at that address')
		exit()		

print('Cycle on/off until ^C break')

# now cycle

while 1 :
	ser.write('h%02X00\n'%(address))
	print (' Off ')
	time.sleep(2)
	ser.write('h%02X%02X\n'%(address-1,level))
	print (' Up ')
	time.sleep(2)



