#!/usr/bin/python
#
# program to update the low current Vf basis for counting attached LEDs
#

import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.2,
)


def SetBank(Bank,Location) :
	global index
	ser.write('hC3%02X\n'%Bank)
	x=ser.read(2)
	ser.write('hA3%02X\n'%Location)
	index = Location
	x=ser.read(2)
	return

def WaitFor(mask,flag):
	Delta = 0
	Result = flag + 1
	print('Wait for %x'%flag)

	while( Result != flag):
		time.sleep(1)
		y='N'
		while( y == 'N'):
			crlf = ser.read(1)
			ser.write('h%02X90\n'%device)
			x = ser.read(1)
			y = readpacket(x)

		if( y == 'J' ) :
			Result = int(DALIdata,16) & mask
			if(Delta != DALIdata):
				print('%s'%DALIdata)
				Delta = DALIdata
		else:
			print('Unexpected %s'%y)
	return


def NoFade(device) :
	WaitFor(0x10,0)
	return

def readData(seed,device) :
	global index
	ser.write('h%02xC5\n'%device) 
	x=ser.read(1)
	if( x != 'J'):
		y = ser.read(1)
		x = ser.read(1)
		if( x == 'J' ) : # delayed
			print('d'),
		while( x != "J"):
			z = ser.read(10) # not delayed read
			print('%s%s%s'%(y,x,z))
 			ser.write('h%02x98\n'%device) # check DTR
			ser.read(1)
			x = ser.read(2)
			DTR = int(x,16)
			ser.read(1)
			if(DTR == index + 1): # missed the response
				ser.write('hA3%02X\n'%index)
				ser.read(2)
				print(' r '),
			elif(DTR == index) : # missed the query
				print(' q '),
			else :
				print('??'),
			ser.write('h%02xC5\n'%device) # read again
			x = ser.read(1)

		data=ser.read(2)
		ser.read(1)
	else : # normal read
		data=ser.read(2)
		ser.read(1)

	index = index + 1
	seed = seed*256 + int(data,16)
	return seed

def lsbFirst(device) :
	lsb = readData(0,device)
	return readData(0,device)*256 + lsb


def sendCMD(bus,d0,d1) :
	if(bus == '') :
		ser.write('h%02X%02X\n'%(d0,d1))
	else :
		ser.write('%sh%02X%02X\n'%(bus,d0,d1))

def readpacket(FirstChar ) : # hjn etc
	global DALIdata

	x = FirstChar
	while( 1 ) : 
		if( x == '') :
			return x
		if( x == 'N' ):
			crlf = ser.read(1)
			return x
		if( x == 'J' ):
			DALIdata = ser.read(2)
			crlf = ser.read(1)
			return x
		if( x == 'H' ):
			DALIdata = ser.read(4)
			crlf = ser.read(1)
			return x
		if( x == 'L' ):
			DALIdata = ser.read(6)
			crlf = ser.read(1)
			return x
		if( x == 'B' or x == 'V'):
			DALIdata = ser.read(6)
			crlf = ser.read(1)
		if( x == 'D' ):
			DALIdata = ser.read(2)
			crlf = ser.read(1)
		if( x == 'P' ):
			DALIdata = ser.read(5)
			crlf = ser.read(1)
		if( x == 'Q' ):
			DALIdata = ser.read(16)
			crlf = ser.read(1)
		if( x == 'X' ):
			DALIdata = ser.read(1)
			crlf = ser.read(1)
		if( x == 'Z' ):
			crlf = ser.read(1)
		x = ser.read(1)


def readbus(bus) :
	while(1) :
		x=ser.read(1)
		if(x == '1' or x == '2' or x == '3') :
			y=ser.read(1)
			type = readpacket(y) # get the packet
			ix = int(x,10)
			ibus = int(bus,10) 
			if(ix == ibus) :
				return type
		else:
			type = readpacket(x) # get the packet
			return(type)



def writeMemory(bus,bank,address,device) :
	sendCMD(bus,0xC3,bank)
	type=readbus(bus)
	sendCMD(bus,0xA3,address)
	type=readbus(bus)
	ser.write('%st%02x81\n'%(bus,device)) # enable
	type=readbus(bus)
	type=readbus(bus)
	ser.write('%shC7%02X\n'%(bus,Data))   # write dest
	type=readbus(bus)
	print('write EEprom')
	time.sleep(3) # older versions need time to write
	return type



print('\n      ATX LED Consultants Inc - Set Vf ideal \n')


ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print('  Serial Port Conflict  \n\n')
	exit()

x=ser.read(2)
print('Hat HW version: %s'%(x))
y=ser.read(2)
y=int(y,16)
print('Hat FW version: %d'%(y))
x=ser.read(2)
if x != "" :
	print('HW Type         %s'%(x))
ser.read(1)

if len(sys.argv) < 2 :
	text = input("input address to manage : ")
else:
	text = sys.argv[1]

device = int(text)*2+1

# dtr1, 0 as 0:3 

ser.read(100)

SetBank(0,9)

fw = readData(0,device)
print('FW version:     %02d'%(fw))
hwv = readData(0,device)
print('HW version:     %02d'%(hwv))

if(fw < 54 ):
	print(' too old %d'(fw))
	exit()

# send arc 32
ser.write('h%02X20\n'%(device-1))
time.sleep(1)
# send level 64
ser.write('h%02X40\n'%(device-1))
WaitFor(0x97,7)
# turn off
ser.write('h%02X00\n'%(device-1))
WaitFor(0x94,0)

#Data = 0
#writeMemory(0,0,15,device)


if( hwv  > 2) :
	SetBank(4,3)
	hours = lsbFirst(device)
	print('Uptime %d hours'%hours)
	hours = lsbFirst(device)
	print('Ontime %d hours'%hours)
	hourslsb = readData(0,device)
	hours = readData(0,device)*256 + hourslsb

	SetBank(4,12)
	hours = readData(0,device)/10 + hours*100
	print('Wh %d'%hours)
	if( hwv > 2):
		ser.write('h%02XA0\n'%device)
		ser.read(1)
		level = ser.read(2)
		ser.read(1)
		if(level != "00"):
			ser.write('h%02X00\n'%device) # off
			ser.read(2)
			NoFade(device)

		add = 0
		NewHeight = 0
		while( add < 2 ) :
			if(add == 0):
				print('Right'),
			else :
				print('Left'),

			SetBank(5,36 + add*2)
			TotalV = lsbFirst(device)
			SetBank(5,44 + add )
			if(NewHeight == 0 ):
				Height = readData(0,device)
			else:
				Height = NewHeight
			SetBank(5,78 + add)
			Offset = readData(0,device)
			if(Offset > 127 ) :
				Offset = -256 + Offset
			if(Height == 0 ):
				Height = -1
				Ideal = 2520
			else: 
				Ideal = TotalV/Height

			print('      Height %2d  Voltage %d Ideal %5d  Existing %5d'%(Height, TotalV, Ideal, 2500 + (Offset*10) ))
			text = raw_input("New Height : ")
			if ( text != "" and text != 'q'):
				NewHeight = int(text,10)
				NewOffset = ( Ideal - 2500 ) / 10
				if(NewOffset < 0 ) :
					Data = 255 + NewOffset
				else :
					Data = NewOffset
				print(' New Offset %2d %d'%(NewOffset, Data))
				writeMemory("",5,78+add,device)				
			else:
				add = add + 1
				NewHeight = 0

sendCMD("",device,6)
time.sleep(1)
WaitFor(0x80,0x80)

ser.write('h%02X20\n'%(device-1))

print('Waiting for Calibration')

WaitFor(0x94,4)

print('Done')
