# Test the DALI bus
# then set 75% 10%
# send to bus
# loop to input

import RPi.GPIO as GPIO 
import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS, 
	timeout=1,
)
x=ser.read(10000)

ser.write('v\n')  # lets get version number first
x=ser.read(1)
if x == "" :
	print('\n Serial Port not configured \n\n')
	exit()

x=ser.read(2)
print('\nHW version: %s'%(x))
y=ser.read(2)
print('FW version: %s'%(y))
x=ser.read(2)
if x != "" :
	print('HW Type %s'%x)
x=ser.read(1)

ser.write('d\n')  # now check if Power is good
x=ser.read(1)
BusTest = 0
print '     ',
while x == 'D' :
	y=ser.read(1)
	y=int(y,16)
	if y == 0 :
		print('DALI BUS: power is lost')
	if y == 1 :
		print('DALI BUS: power is stuck high')
	if y == 2 :
		print('DALI BUS: power is good')
	if y == 3 :
		print('DALI BUS: power is not yet known')
	BusCount = int(ser.read(1),10)
	crlf=ser.read(1)
	BusTest = BusTest + 1
	if BusTest < BusCount:
		ser.write('%dd\n'%BusTest )  # now check if Power is good
		x=ser.read(1) # Busnumber
		x=ser.read(1)
		print( 'Bus %d'%(BusTest+1) ),
	else :
		x = ''

print('%s channel(s)'%BusCount)

end=1

while end :
	text = raw_input("\nWhich DALI address ( 0-63, 64-79 Group, 127=all, q(uit) ) : ")
	if text == 'q' :
		end=0
		exit()

	BusTest = 0
	BusCycle = ""
	while BusTest < BusCount:
		print('Bus %d '%BusTest),

		address = int(text)*2
		if(BusCount == 1):
			ser.write('h%02XA0\n'%(address+1))
			x=ser.read(1)
		else :
			ser.write('%dh%02XA0\n'%(BusTest,address+1))
			x=ser.read(1)
			xs = '%d'%BusTest
			if( x == xs):
				x=ser.read(1)

		if x == 'J' :
			BusCycle = xs
			x=ser.read(2)
			x = int(x,16)
			print(' current level is %d'%x)
			x = ser.read(1)
		if x == 'N' :
			print(' no device ')
			ser.read(1)
		if x == 'X' :
			BusCycle = xs
			print(' Multiple Devices ')
			ser.read(1)
		BusTest = BusTest + 1


	while (1) :

		level = 0
		print(' 0% ')
		ser.write('%sh%02X%02X\n'%(BusCycle, address, level))   # send level
		ser.read(2) # nak

		time.sleep(1)	

		level = 200
		print(' 80% ')

		ser.write('%sh%02X%02X\n'%(BusCycle, address, level))   # send level
		ser.read(2) # nak

		time.sleep(1)	
		
