# Display status of the AL-PSE-4D 

import time
import serial
import sys

rbus = 0

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.5,
)

global Caddress
global ModeNow

def Read( expected, String ):  # 8 or 16 
	x=ser.read(1)

	rbus = 1
	y=0

	if x == '1' :
		rbus = 2
		x=ser.read(1)
	if x == '2' :
		rbus = 3
		x=ser.read(1)
	if x == '3' :
		rbus = 4
		x=ser.read(1)

	while x != 'J':
		if x == 'N':
			if( expected > 0) :
				print('            bus %d No Answer to %s'%(rbus,String))
			else :
				x= ser.read(1)
				return 999
		elif x == 'H' :
			ser.read(5)
		elif x == "" :
			return x
		else :
			print('err 1 %s'%x)
			x=ser.read(100)
			print('err 100 %s'%x)
			return 999
		x=ser.read(1)

	if x == 'J' :
		y=ser.read(2)
		y=int(y,16)
		if(expected < 2):
			if( rbus > 1 ):
				print('              %s %02X on bus %d '%(String,y,rbus))
			else :
				print('              %s %02X '%(String,y))
		crlf=ser.read(1)

	return y


def ReadAdd(bank, register, dadd) :
	global DBus

	ser.write('%shC3%02x\n'%(DBus,bank))  # set DTR1
	Read(0,"DTR")
	ser.write('%shA3%02X\n'%(DBus,register))  # set DTR
	Read(0,"DTR")

	ser.write('%sh%02XC5\n'%(DBus,dadd))  # read address
	response = Read(2,"Address")

	return response


def Read16b(dadd, Bank, BAddress) : # read 16 bit value
	global DBus

	Result = ReadAdd(Bank, BAddress, dadd)
	ser.write('%sh%02XC5\n'%(DBus,dadd))  # read address
	Result = 256 * Read(2,"value") + Result
	return Result

def Read16bn(dadd) : # read 16 bit value next 2
	global DBus

	ser.write('%sh%02XC5\n'%(DBus,dadd))  # read address
	Result = Read(2,"value lsb")
	ser.write('%sh%02XC5\n'%(DBus,dadd))  # read address
	Result = 256 * Read(2,"value msb") + Result
	return Result

def Print16b(dadd, Bank, BAddress, Name) :

	value = Read16b(dadd, Bank, BAddress)
	print(' %s %6d'%(Name,value))
	return

def Print16b0(dadd, Bank, BAddress, Name) :

	value = Read16b(dadd, Bank, BAddress)
	print(' %s %6d mW'%(Name,(value*10)))
	return

def Print16bx4(dadd, Bank, BAddress, Name, mult) :
	print(' %s'%Name),

	i=0
	while i< 4 :
		if(i==0) :
			value = Read16b(dadd, Bank, BAddress + i*2)
		else :
			value = Read16bn(dadd)

		print ('%6d '%(value*mult)),
		i = i+1
	print('')
	return

def Write(dadd, Bank, BAddress, Data) :
	global DBus
	cbus =2 # read 2 characters

	if(DBus != ""):
		cbus = 3

	ser.write('%shC3%02X\n'%(DBus,Bank))  # set DTR1
	ser.read(cbus)
	ser.write('%shA3%02X\n'%(DBus,BAddress))  # set DTR
	ser.read(cbus)
	ser.write('%st%02X81\n'%(DBus,dadd))  # enable write
	ser.read(2*cbus)
	ser.write('%shC7%02X\n'%(DBus,Data))  # write mode byte
	print('Write %d %d %d'%(dadd/2,Bank,BAddress)),
	Read(1,"Data=")
	time.sleep(.25)

ser.read(10000)
DBus = ""
dbus = 0
input = raw_input("input Bus # [1-4] ")  # enter 1 
if input == "2" :
	DBus ="1"
	dbus = 1
if input == "3" :
	DBus ="2"
	dbus = 2
if input == "4" :
	DBus ="3"
	dbus = 3

x = ""

ModeNow =0
dadd = 1000
while 1 :
	if (x =="" ) :
		address=1000
		while(address > 63):
			if(dadd == 1000) :
				address = raw_input("input AL-PSE-4D Address dd : ")  # enter decimal
			else :
				address = raw_input("input AL-PSE-4D Address, s=scan DALI M=1900mA R=Clear SA\n                         z=CalZero 5=Cal51v, m=Cal_100m\n(q, s, R, z, 5, m, dd) : ")  # enter decimal
			ser.read(10000)
			if(address == 'q') :
				exit()
			if(address == 'z') :
				Write(dadd,5,26,55)
				time.sleep(7)
				address = '%s'%(dadd/2)
			if(address == 'R') :
				print(' reset all inc. SA ')
				ser.write('%st%02X20\n'%(DBus,dadd))  # reset
				ser.write('%shA3FF\n'%(DBus))  # set DTR 255
				ser.write('%sh%02X80\n'%(DBus,dadd))  # reset
				continue
			if(address == '5') :
				Write(dadd,5,26,56)
				time.sleep(7)
				address = '%s'%(dadd/2)
			if(address == 'm') :
				Write(dadd,5,26,57)
				address = '%s'%(dadd/2)
			if(address == 'M') :
				Write(dadd,5,21,190)
				Write(dadd,5,22,190)
				Write(dadd,5,23,190)
				Write(dadd,5,24,190)
				address = '%s'%(dadd/2)
			if(address == 's') : # scan bus
				print(' scan for clients in 60 seconds')
				ser.write('%st%02X20\n'%(DBus,dadd))  # reset
				Status = 16;
				while (Status & 0x10 ) : 
					time.sleep(5)
					x = ser.read(10000)
					if( x == "") :
						print(' test if ready ')
						ser.write('%sh%02X90\n'%(DBus,dadd))  # reset
						Status = Read(2,"Status")
				address = dadd/2
				continue
			address = int(address,10)
		ser.read(10000)
		dadd = address * 2 + 1

		ser.write('%sh%02XA6\n'%(DBus,dadd))  # ping 
		there = Read(2,"HW Type")
		if( there == 14) :
			print(' AL-PSE-4D found at address %d '%address),
			x = ReadAdd(5,1,dadd)
			print(' Firmware %d'%x),
			x = ReadAdd(5,3,dadd)
			print(' Calibration %d \n'%x)
		else:
			print(' No device at this address %d'%address)
			continue;

		ser.write('%sh%02XA4\n'%(DBus,dadd))  # Power Status
		power = Read(2,"Power")
		there = 32
		while (there & 32) :
			ser.write('%sh%02X90\n'%(DBus,dadd))  # status
			there = Read(2,"Status")
		InStr = bin(power/16)
		OutStr = bin(power&15)
		print(' In Power: %s OutPower: %s Status: %2x '%(InStr,OutStr,there))
		print('                  D       C       B       A ')

		Print16bx4(dadd, 4, 7,"Volts In   ",1)
		Print16bx4(dadd, 4,31,"Current In ",1)
		Print16bx4(dadd, 4,15,"Volts Out  ",1)
		Print16bx4(dadd, 4,23,"Current Out",1)
		Print16bx4(dadd, 4,47,"mWatts  Out",10)
		print(" MaxCurrent "),
		i=84
		while(i < 97):
			data = ReadAdd(5,i, dadd)
			print("  %d "%(data*10)),
			i = i + 4
		print('\n')

		i=0
		while(i < 16):
			Result = ReadAdd(7, i, dadd)
			if(Result > 0) :
				print(' Bad Solder %x %d %x '%(10+i/4,i&3,Result))
			i = i+ 1

		Print16b(dadd, 7, 17,"Alt V      ")
		Print16b(dadd, 7, 19,"16 VAC     ")
		Print16b(dadd, 7, 21,"GFCI       ")
		Print16b(dadd, 7, 23,"Vt         ")
		Print16b(dadd, 7, 25,"Watts total")
		Print16b(dadd, 7, 37,"WattMinutes")

		print('\nClients')
		TestCH = 0
		ReadCH = 255
		SAtest = 0
		Value = ReadAdd(6, 64, dadd)
		while(TestCH < 4 and SAtest < 64) :
			if( Value < 4) : # got an attached device
				print ('%2d Channel %d'%(SAtest,Value)),
				Watts = ReadAdd(6, SAtest, dadd)
				print ('Watt %d'%Watts)
				Value = ReadAdd(6, 64 + SAtest + 1, dadd)
			else :
				ser.write('%sh%02XC5\n'%(DBus,dadd))  # read address
				Value = Read(2,"Address")
			SAtest = SAtest + 1
		print('end\n')

	while x == 'H' :
		x1=ser.read(4)
		x2=ser.read(4)
		print('bus data H %s %s on %d '%(x1,x2,rbus))
		if(x1 == "A3"): # DTR
			time.sleep(5)
		crlf=ser.read(1)
		x=ser.read(1)
		if x == '1' :
			rbus = 4
			x=ser.read(1)
		if x == '2' :
			rbus = 4
			x=ser.read(1)
		if x == '3' :
			rbus = 4
			x=ser.read(1)
	if x == 'N' :
		print('no response')

	if x == 'X' :
		print('Framing Error')
		x=ser.read(10)
		print('                      Error X %s'%(x))
		x=ser.read(10)

	if x == 'Z' :
		print('Collision')
		x=ser.read(10)
		print('                      Error Z %s'%(x))
	if x == 'P' :
		print('Power Change')
		x=ser.read(10)
		print('                      Power Change %s'%(x))
	if x == 'Q' :
		print('Dali Change')
		x=ser.read(100)
		print('                      DALI Change %s'%(x))

	Read(0,"Loop")
	x = ""
