# test DALI device ability to drive the bus

import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)

print(' Started - doing driver test first')
ser.write('q0\n')  # do bus test
x=ser.read(100)
ser.write('q6\n')  # do bus query

x=ser.read(1)

while 1 :
	if x == "" :
		message = raw_input("input Address to test, q to quit : ")  # enter 1 character
		if message == 'q' :
			exit()
		if message == '' :
			exit()
		uppermsg = message.upper()
		dec = int(uppermsg,10)
		a = dec *2 + 1
		ser.write('h%02X99\n'%a)  # query device - get drive current
		x=ser.read(1)
		if x == "J" :
			x=ser.read(2)
			if x != "00" :
				x=ser.read(1)
				ser.write('u%s\n'%(uppermsg))  # write uxx where XX is the address 0-64  (ignored by HW today )
			else :
				print(' Need non Zero response')
			x=ser.read(1)

	if x == 'H' :
		x=ser.read(4)
		print('bus data H%s'%(x))
		x=ser.read(1)

	if x == 'J' :
		y=ser.read(2)
		y=int(y,16)
		print('                      Answer %02x'%(y))
		x=ser.read(1)

	if x == 'B' :
		y=ser.read(7)
		print('                      Answer %x'%(y))
		x=ser.read(1)

	if x == 'V' :
		y=ser.read(7)
		print('                      Answer %x'%(y))
		x=ser.read(1)

	if x == 'X' :
		print('Framing Error')
		x=ser.read(1)

	if x == 'Z' :
		print('Collision')
		x=ser.read(1)

	if x == 'U' :
		x=ser.read(5)
		x = int(x,10)
		print('\n Local FetRdsOn %d '%(x))
		x=ser.read(4)
		x = int(x,10)
		print(' Remote DALI device logic level zero = %d mV ( ohms = %d ) \n'%(x,x/operate))
		x=ser.read(4)

	if x == 'Q' :
		print('\n Dali Power'),
		x=ser.read(1)
		x = int(x,10)
		locked = "Auto"
		if x > 3 :
			x = x & 3
			locked = "locked"
		print(' Mode %d %s'%(x,locked))
		x=ser.read(5)
		print(' Volts %s'%(x)),
		x=ser.read(3)
		operate = int(x,10)
		print(' mA Operate %s'%(x)),
		x=ser.read(4)
		print(' mA Start %s'%(x)),
		x=ser.read(4)
		print(' mA Finish %s'%(x))
		ser.write('p\n')  # get power 
		x=ser.read(1)
		
	if x == 'P' :
		print(' Supply Power'), 
		x=ser.read(3)
		print('          Volts A %s'%(x)),
		x=ser.read(3)
		print(' Volts B %s'%(x)),
		x=ser.read(2)
		print(' Switch %s'%(x))


	x=ser.read(1)
