#
#
# program to read the info about one DALI device
# display the serial number, UPC code and firmware versions
#
#

import RPi.GPIO as GPIO
import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)

GPIO.setmode(GPIO.BCM)
GPIO.setup(5,GPIO.IN)
GPIO.setup(6,GPIO.IN)

print('\n      ATX LED Consultants Inc - Read Model, Type, UPC, Version, SN \n')


ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print('  Serial Port Conflict  \n\n')
	exit()

x=ser.read(2)
print('Hat HW version: %s'%(x))
y=ser.read(2)
y=int(y,10)
print('Hat FW version: %d'%(y))
x=ser.read(2)
if x != "" :
	print('HW Type %s'%(x))
ser.read(1)


if len(sys.argv) < 2 :
	text = input("input address to read : ")
else:
	text = sys.argv[1]
device = int(text)*2+1

# dtr1, 0 as 0:3 
ser.write('hC300\n')
time.sleep(.1)
x=ser.read(2)
ser.write('hA303\n')
time.sleep(.1)
x=ser.read(2)

# read memory - upc msb
ser.reset_input_buffer()
ser.write('h%02xC5\n'%device) 
x=ser.read(1)
x=ser.read(3)
UPC=int(x,16)
ser.write('h%02xC5\n'%(device)) 
x=ser.read(1)
x=ser.read(3)
UPC = UPC*256+int(x,16)
ser.write('h%02xC5\n'%(device)) 
x=ser.read(1)
x=ser.read(3)
UPC = UPC*256+int(x,16)
ser.write('h%02xC5\n'%(device)) 
x=ser.read(1)
x=ser.read(3)
UPC = UPC*256+int(x,16)
ser.write('h%02xC5\n'%(device)) 
x=ser.read(1)
x=ser.read(3)
UPC = UPC*256+int(x,16)
ser.write('h%02xC5\n'%(device)) 
x=ser.read(1)
x=ser.read(3)
UPC = UPC*256+int(x,16)
if( UPC != 281474976710655 ) :
	print('UPC: %ld'%(UPC))
else:
	print(' No UPC')

ser.write('h%02xC5\n'%(device)) 
time.sleep(.1)
x=ser.read(1)
x=ser.read(3)
x=int(x,16)
print('FW version: %02d'%(x))
ser.write('h%02xC5\n'%(device)) 
x=ser.read(1)
x=ser.read(3)
x=int(x,16)
print('HW version: %02d'%(x))

ser.write('h%02xC5\n'%(device)) 
time.sleep(.1)
x=ser.read(1)
x=ser.read(3)
SN= int(x,16)
ser.write('h%02xC5\n'%(device)) 
time.sleep(.1)
x=ser.read(1)
x=ser.read(3)
SN = SN*256+int(x,16)
ser.write('h%02xC5\n'%(device)) 
time.sleep(.1)
x=ser.read(1)
x=ser.read(3)
SN = SN*256+int(x,16)
ser.write('h%02xC5\n'%(device)) 
time.sleep(.1)
x=ser.read(1)
x=ser.read(3)
SN = SN*256+int(x,16)
if(SN != 4294967295):
	print('Serial Number Hex: %08X'%(SN))

ser.write('h%02xC5\n'%(device)) 
time.sleep(.1)
x=ser.read(1)
x=ser.read(3)
y=int(x,16)
if(y != 255):
	print('N-Mode: %d'%(y))

ser.write('h%02xC5\n'%(device)) 
time.sleep(.1)
x=ser.read(1)
x=ser.read(3)
y=int(x,16)
if( y < 64):
	print('2nd Short Address is : %d'%(y))
elif (y == 127):
	print('2nd is Broadcast')
elif (y < 127):
	print('2nd is Group : %d'%(y&15))
elif (y == 255):
	print('2nd SA/Group is disabled')
print('\n\n')

	
