# send any DALI command as 2 bytes
# enter the 2 bytes as HEX values
# run the Monitor program to observe the response 

import time
import serial
import sys

rbus = 0

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)

def Read():
	x=ser.read(1)

	rbus = 1

	if x == '1' :
		rbus = 2
		x=ser.read(1)
	if x == '2' :
		rbus = 3
		x=ser.read(1)
	if x == '3' :
		rbus = 4
		x=ser.read(1)

	if x == 'N':
		print('                   No Answer')
		x=ser.read(1)

	if x == 'X':
		print('                   Collision')
		x=ser.read(2)

	if x == 'J' :
		y=ser.read(2)
		y=int(y,16)
		if( rbus > 1 ):
			print('                      Answer %02x on %d '%(y,rbus))
		else :
			print('                      Answer %02x '%(y))
		x=ser.read(1)

	return x

bus = ""
dbus = 4
while dbus > 3 :
	input = raw_input("input Bus # ")  # enter 1 
	dbus = int(input,10)
if input == "2" :
	bus ="1";
if input == "3" :
	bus ="2";
if input == "4" :
	bus ="3";


while 1 :
	x = Read()

	if (x =="" ) :
		address=1000
		while(address > 63 and address != 127):
			address = raw_input("input Address (0-63, 127=all): ")  # enter decimal
			address = int(address,10)
		command = raw_input("input Command (in decimal): ")  #
		command = int(command,10)

		message = address*2+1
		ser.write('%sh%02X98\n'%(bus,message))  # read DTR
		print('Read DTR '),
		Read()
		ser.write('%sh%02X9C\n'%(bus,message))  # read DTR1
		print('Read DTR1'),
		Read()
		ser.write('%sh%02X9D\n'%(bus,message))  # read DTR2
		print('Read DTR2'),
		Read()

		if(command >= 231 and command <= 256) :

#			ser.write('%shC108\n'%(bus))  # write hXXYY where XX is the first DALI byte and YY the 2nd
#			y=ser.read(2)
			ser.write('%sh%02X97\n'%(bus,message))  # write hXXYY where XX is the first DALI byte and YY the 2nd
			print('Read Version @97'),
			Read()
			ser.write('%shC108\n'%(bus))  # write hXXYY where XX is the first DALI byte and YY the 2nd
			y=ser.read(2)
			ser.write('%sh%02X99\n'%(bus,message))  # write hXXYY where XX is the first DALI byte and YY the 2nd
			print('Read Type    @99'),
			Read()

			if( command == 250 ) :
				ser.write('%sh%02X90\n'%(bus,message))  # write hXXYY where XX is the first DALI byte and YY the 2nd
				ser.write('%sh%02XA1\n'%(bus,message))  # write hXXYY where XX is the first DALI byte and YY the 2nd
				ser.write('%sh%02XA2\n'%(bus,message))  # write hXXYY where XX is the first DALI byte and YY the 2nd
				ser.write('%sh%02XA3\n'%(bus,message))  # write hXXYY where XX is the first DALI byte and YY the 2nd

			y=ser.read(8)
			ser.write('%shC108\n'%(bus))  # write hXXYY where XX is the first DALI byte and YY the 2nd
			y=ser.read(2)
			time.sleep(.2)

		message = ( ( address*2+1 )* 256 ) + command
		if command < 144 :
			print 'Sent twice'
			expres = 1
			ser.write('%st%04X\n'%(bus,message))  # write hXXYY where XX is the first DALI byte and YY the 2nd
			x=Read()
		else :
			expres = 0
			ser.write('%sh%04X\n'%(bus,message))  # write hXXYY where XX is the first DALI byte and YY the 2nd
			print('Send %x'%message),
			x=Read()

	while x == 'H' :
		x=ser.read(4)
		print('bus data H%s on %d '%(x,rbus))
		x=ser.read(1)
		x=ser.read(1)
		if x == '1' :
			rbus = 4
			x=ser.read(1)
		if x == '2' :
			rbus = 4
			x=ser.read(1)
		if x == '3' :
			rbus = 4
			x=ser.read(1)
	if x == 'N' :
		if expres == 1 :
			expres = 0
		else :
			print('no response')

	if x == 'X' :
		print('Framing Error')
		x=ser.read(10)
		print('                      Answer %s'%(x))
		x=ser.read(10)

	if x == 'Z' :
		print('Collision')
		x=ser.read(10)
		print('                      Answer %s'%(x))
	if x == 'P' :
		print('Power Change')
		x=ser.read(10)
		print('                      Answer %s'%(x))
	if x == 'Q' :
		print('Dali Change')
		x=ser.read(100)
		print('                      Answer %s'%(x))

