#
#
# program to write to memory in a DALI driver
# see manual for more info ( AL-WS-DR2 etc)
#

import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.2,
)

def readpacket(FirstChar ) : # hjn etc
	global DALIdata

	x = FirstChar
	while( 1 ) : 
		if( x == '') :
			return x
		if( x == 'N' ):
			crlf = ser.read(1)
			return x
		if( x == 'J' ):
			DALIdata = ser.read(2)
			crlf = ser.read(1)
			return x
		if( x == 'H' ):
			DALIdata = ser.read(4)
			crlf = ser.read(1)
			return x
		if( x == 'L' ):
			DALIdata = ser.read(6)
			crlf = ser.read(1)
			return x
		if( x == 'B' or x == 'V'):
			DALIdata = ser.read(6)
			crlf = ser.read(1)
		if( x == 'D' ):
			DALIdata = ser.read(2)
			crlf = ser.read(1)
		if( x == 'P' ):
			DALIdata = ser.read(5)
			crlf = ser.read(1)
		if( x == 'Q' ):
			DALIdata = ser.read(16)
			crlf = ser.read(1)
		if( x == 'X' ):
			DALIdata = ser.read(1)
			crlf = ser.read(1)
		if( x == 'Z' ):
			crlf = ser.read(1)
		x = ser.read(1)



def readbus(bus) :
	while(1) :
		x=ser.read(1)
		if(x == '1' or x == '2' or x == '3') :
			y=ser.read(1)
			type = readpacket(y) # get the packet
			ix = int(x,10)
			ibus = int(bus,10) 
			if(ix == ibus) :
				return type
		else:
			type = readpacket(x) # get the packet
			return(type)


def readData(bus,seed,device,base) :
	global DALIdata
	global index

	ser.write('%sh%02xC5\n'%(bus,device*2+1))  # read memory
	type = readbus(bus)
	while ( type == 'H'):  # other bus traffic
		type = readbus(bus)
	if( x == 'N'):
		return 0

	index = index + 1
	seed = seed*256 + int(DALIdata,base)
	return seed


def sendCMD(bus,d0,d1) :
	if(bus == '') :
		ser.write('h%02X%02X\n'%(d0,d1))
	else :
		ser.write('%sh%02X%02X\n'%(bus,d0,d1))


def readMemory(bus,bank,address,device) :
	sendCMD(bus,0xC3,bank)
	type=readbus(bus)
	sendCMD(bus,0xA3,address)
	type=readbus(bus)
	sendCMD(bus,device*2+1,0xC5)
	type=readbus(bus)
	return(type)


def writeMemory(bus,bank,address,device) :
	sendCMD(bus,0xC3,bank)
	type=readbus(bus)
	sendCMD(bus,0xA3,address)
	type=readbus(bus)
	ser.write('%st%02x81\n'%(bus,device*2+1)) # enable
	type=readbus(bus)
	type=readbus(bus)
	ser.write('%shC7%02X\n'%(bus,Data))   # write dest
	type=readbus(bus)
	print('write EEprom')
	time.sleep(3) # older versions need time to write
	return type


ser.read(10000) # clear fifo

print('\n\n')
print('      ATX LED Consultants Inc - Set AL-WS-010v options')
print('')
ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print(' Serial Port not configured \n\n')
	exit()

x=ser.read(2)
hw=0
if x != "" :
	hw=int(x,10)
print('AL-DALI-Hat: HW version: %d'%(hw))

y=ser.read(2)
print('AL-DALI-Hat: FW version: %s'%(y))
fwver = int(y,10)

hwtype=0
y=ser.read(2)
if y != "\n" :
	hwtype=int(y,10)
	y=ser.read(1)

channels = 1

if hwtype == 2 :
	channels = 2
elif hwtype == 4 :
	channels = 4

bus = ''
if(channels > 1) :
	text = raw_input("Which DALI bus ( 1-4) : ")
	if(text== "2"):
		bus = '1'
	if(text== '3'):
		bus = "2"
	if(text== '4'):
		bus = "3"

text = input("Which DALI address ( 0-63, 127=all ) : ")
device = int(text)

usertext = 'g'
ack="   "
DALIdata ='0000'


while(usertext != 'q') :
	sa2   = readMemory(bus,0,16,device)

	if( sa2 == 'N' ) :
		print(' Address %02d no device '%(device)),
		sys.exit()

	sa2 = int(DALIdata,16)
	readMemory(bus,0,17,device)
	phyl  = int(DALIdata,16)
	readMemory(bus,0,18,device)
	phyh  = int(DALIdata,16)
	readMemory(bus,0,19,device)
	dcool  = int(DALIdata,16)
	readMemory(bus,0,20,device)
	dwarm  = int(DALIdata,16)

	print(' %02d sa2= %02d phyl= %02d phyh = %02d cool = %4d warm = %4d '%(device,sa2,phyl/25,phyh/25,5000-dcool*13,5000-dwarm*13))


	usertext = raw_input("      What data to write (s, l, h, c, w, q)  : ")
#	print('clear FiFo')
	ser.read(1000)
	if usertext == 'q' :
		sys.exit()
	uservalue = raw_input("      What value: ")
	value = int(uservalue,10)

	if usertext == 's' :
		add = 16
	if usertext == 's' :
		add = 17
		value = value * 25
	if usertext == 'h' :
		add = 18
		value = value * 25
	if usertext == 'c' :
		add = 19
		value = (5000 - value ) / 13
	if usertext == 'w' :
		add = 20
		value = (5000 - value ) / 13

	Data = value
	print(' Memory %d value %d'%(add,Data))
	type = writeMemory(bus,0,add,device)

