#
#
# program to change a Short address to a new one, or to remove the short address
#
#
import RPi.GPIO as GPIO
import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS, 
	timeout=.2,
)

GPIO.setmode(GPIO.BCM)
GPIO.setup(5,GPIO.IN)
GPIO.setup(6,GPIO.IN)

print('\n\n')
print('      ATX LED Consultants Inc - Fixture Minimum ')
print('')


ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print('  Serial Port Conflict  \n\n')
	exit()

x=ser.read(2)
print('HW version: %s'%(x))
y=ser.read(2)
print('FW version: %s'%(y))
crlf=ser.read(100)

ser.write('hFF96X\n') # detect missing address
res = ser.read(1)
if( res != 'N' ) :
	print('at least one unassigned address')


if len(sys.argv) > 1 :
	address = int((sys.argv[1]),10)*2 + 1
	sa2 = 255
else:
	text = input("Which DALI address ( 0-63) : ")
	address = int(text)*2+1

	text = raw_input("          What new Address (0-63,none): ")
	if(text == "none" or text == "n" or text == "255") :
		sa2 = 255
	else :
		sa2 = int(text)*2+1

ser.write('hA3%02X\n'%(sa2)) # load DTR
time.sleep(.1)
ser.write('t%02X80\n'%(address))  # set DTR to Short Address
ser.read(1000)
time.sleep(.1)

# now cycle until ^C

address = sa2

while sa2 != 255 :
	ser.write('h%02X06\n'%(address))
	print('set Min ')
	time.sleep(2)
	ser.write('h%02X05\n'%(address))
	print('set Max ')
	time.sleep(2)

if(sa2 == 255 ):
	ser.write('hFF96X\n') # detect missing address
	res = ser.read(1)
	if( res == 'J' ) :
		print('address reset success ')
