#
#
# program to write to memory in a DALI driver
# see manual for more info ( AL-WS-DR2 etc)
#

import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)


print('\n      ATX LED Consultants Inc - Set CCT Range ')

text = input("Which DALI address ( 0-63, 127=all ) : ")
address = int(text)*2

usertext = 'g'
ack="   "

while(usertext != 'q') :
	ser.write('hC305\n')
	x=ser.read(2)
	ser.write('hA30A\n')
	x=ser.read(2)
	ser.write('h%02xC5\n'%(address+1))
	x=ser.read(1)
	if( x == 'N' ) :
		print(' Address %02d no device '%(address/2)),
		sys.exit()
	x=ser.read(2)
	Left=5000-(int(x,16)*13) # 6.5 x 2
	y=ser.read(1)
	ser.write('h%02xC5\n'%(address+1))
	x=ser.read(1)
	x=ser.read(2)
	Right=5000-(int(x,16)*13) # 6.5 x 2
	y=ser.read(1)

	print(' Address %02d Left is %02d Right is %02d'%(address/2,Left,Right)),

	if(Right > Left):
		print('Swapped'),

	usertext = raw_input("\n      new Left (2700-5000,q)  : ")
	if usertext == 'q' :
		sys.exit()
	if usertext != "" :
		Left = int(usertext)
	usertext = raw_input("      new Right (2700-5000,q)  : ")
	if usertext == 'q' :
		sys.exit()
	if usertext != "" :
		Right = int(usertext)

	Left = (5000-Left) / 13 # 6.5 x 2
	Right = (5000-Right) / 13

	x=ser.read(1000)
	ser.write('hC305\n')
	x=ser.read(2)
	ser.write('hA30A\n')
	x=ser.read(2)
	ser.write('t%02x81\n'%(address+1))
	x=ser.read(4)
	print(' left %d right %d'%(Left*2,Right*2) )
	ser.write('hC7%02X\n'%(Left))   # write dest
	ack=ser.read(4)

	ser.write('hA30B\n')
	x=ser.read(2)
	ser.write('t%02x81\n'%(address+1))
	x=ser.read(4)
	ser.write('hC7%02X\n'%(Right))   # write dest
	ack=ser.read(4)
	ser.read(1000)
