#
#
# program to write to memory in a DALI driver
# see manual for more info ( AL-WS-DR2 etc)
#

import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.2,
)

def readpacket(FirstChar ) : # hjn etc
	global DALIdata

	x = FirstChar
	while( 1 ) : 
		if( x == '') :
			return x
		if( x == 'N' ):
			crlf = ser.read(1)
			return x
		if( x == 'J' ):
			DALIdata = ser.read(2)
			crlf = ser.read(1)
			return x
		if( x == 'H' ):
			DALIdata = ser.read(4)
			crlf = ser.read(1)
			return x
		if( x == 'L' ):
			DALIdata = ser.read(6)
			crlf = ser.read(1)
			return x
		if( x == 'B' or x == 'V'):
			DALIdata = ser.read(6)
			crlf = ser.read(1)
		if( x == 'D' ):
			DALIdata = ser.read(2)
			crlf = ser.read(1)
		if( x == 'P' ):
			DALIdata = ser.read(5)
			crlf = ser.read(1)
		if( x == 'Q' ):
			DALIdata = ser.read(16)
			crlf = ser.read(1)
		if( x == 'X' ):
			DALIdata = ser.read(1)
			crlf = ser.read(1)
		if( x == 'Z' ):
			crlf = ser.read(1)
		x = ser.read(1)



def readbus(bus) :
	while(1) :
		x=ser.read(1)
		if(x == '1' or x == '2' or x == '3') :
			y=ser.read(1)
			type = readpacket(y) # get the packet
			ix = int(x,10)
			ibus = int(bus,10) 
			if(ix == ibus) :
				return type
		else:
			type = readpacket(x) # get the packet
			return(type)


def readData(bus,seed,device,base) :
	global DALIdata
	global index

	ser.write('%sh%02xC5\n'%(bus,device*2+1))  # read memory
	type = readbus(bus)
	while ( type == 'H'):  # other bus traffic
		type = readbus(bus)
	if( x == 'N'):
		return 0

	index = index + 1
	seed = seed*256 + int(DALIdata,base)
	return seed


def sendCMD(bus,d0,d1) :
	if(bus == '') :
		ser.write('h%02X%02X\n'%(d0,d1))
	else :
		ser.write('%sh%02X%02X\n'%(bus,d0,d1))


def readMemory(bus,bank,address,device) :
	sendCMD(bus,0xC3,bank)
	type=readbus(bus)
	sendCMD(bus,0xA3,address)
	type=readbus(bus)
	sendCMD(bus,device*2+1,0xC5)
	type=readbus(bus)
	return(type)


def writeMemory(bus,bank,address,device) :
	sendCMD(bus,0xC3,bank)
	type=readbus(bus)
	sendCMD(bus,0xA3,address)
	type=readbus(bus)
	ser.write('%st%02x81\n'%(bus,device*2+1)) # enable
	type=readbus(bus)
	type=readbus(bus)
	ser.write('%shC7%02X\n'%(bus,Data))   # write dest
	type=readbus(bus)
	print('write EEprom')
	time.sleep(3) # older versions need time to write
	return type


ser.read(10000) # clear fifo

print('\n\n')
print('      ATX LED Consultants Inc - DALI Set Memory')
print('')
ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print(' Serial Port not configured \n\n')
	exit()

x=ser.read(2)
hw=0
if x != "" :
	hw=int(x,10)
print('AL-DALI-Hat: HW version: %d'%(hw))

y=ser.read(2)
print('AL-DALI-Hat: FW version: %s'%(y))
fwver = int(y,10)

hwtype=0
y=ser.read(2)
if y != "\n" :
	hwtype=int(y,10)
	y=ser.read(1)

channels = 1

if hwtype == 2 :
	print('AL-DALI-2I: Isolated no power\n2 Channels:')
	channels = 2
elif hwtype == 4 :
	print('AL-DALI-4I: Isolated no power\n4 Channels:')
	channels = 4
else :
	print('AL-DALI-Hat: with power v2 \n 1 Channel:')

bus = ''
if(channels > 1) :
	text = raw_input("Which DALI bus ( 1-4) : ")
	if(text== "2"):
		bus = '1'
	if(text== '3'):
		bus = "2"
	if(text== '4'):
		bus = "3"

text = input("Which DALI address ( 0-63, 127=all ) : ")
device = int(text)
text = input("                    What bank (0-5)  : ")
bank = int(text)
text = input("                    What address (0-63)  : ")
address = int(text)

usertext = 'g'
ack="   "
DALIdata ='0000'


while(usertext != 'q') :
	type = readMemory(bus,bank,address,device)

	if( type == 'N' ) :
		print(' Address %02d no device '%(device)),
		sys.exit()

	value=int(DALIdata,16)

	print(' %02d %d:%d is %02d %02X %3.3s'%(device,bank,address,value,value,ack)),

	usertext = raw_input("      What data to write (0-254,r,n,q)  : ")
#	print('clear FiFo')
	ser.read(1000)
	if usertext == 'q' :
		sys.exit()
	ack = ""
	if usertext == 'n' :
		address = address + 1
		continue
	if usertext != 'r' :
		Data = int(usertext)

# dtr1, 0 as 0:15
		type = writeMemory(bus,bank,address,device)
		ack = DALIdata

