# program to set the driver Minimum brightness level
#

import RPi.GPIO as GPIO
import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)

print('\n\n')
print('      ATX LED Consultants Inc - Fixture Minimum ')
print('')

ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print('  Serial Port Conflict  \n\n')
	exit()

x=ser.read(2)
print('HW version: %s'%(x))
y=ser.read(2)
print('FW version: %s'%(y))


text = input("Which DALI address ( 0-63, 127=All) : ")
address = int(text)*2+1

text = input("                   What Min Level : ")
dim = int(text)

ser.write('hA3%02X\n'%(dim)) # load DTR
time.sleep(.1)

ser.write('t%02X2B\n'%(address))  # set DTR to Min level
time.sleep(.1)

text = input("                   What Max Level : ")
dim = int(text)

ser.write('hA3%02X\n'%(dim)) # load DTR
time.sleep(.1)

ser.write('t%02X2A\n'%(address))  # set DTR to Max level
time.sleep(.1)
ser.read(100)

ser.write('h%02XA2\n'%(address)) # query Min
ser.read(1)
x=ser.read(2)
xi = int(x,16)
ser.write('h%02XA1\n'%(address)) # query Max
ser.read(2)
y=ser.read(2)
yi=int(y,16)
ser.write('h%02X9A\n'%(address)) # query Max
ser.read(2)
z=ser.read(2)
zi=int(z,16)
print('Min = %d Max = %d Phy Min = %d'%(xi,yi,zi))


# now cycle until ^C

print('Now Cycle Min / Max until ^C exit')

while 1 :
	ser.write('h%02X06\n'%(address))
	time.sleep(1)
	ser.write('h%02X05\n'%(address))
	time.sleep(1)
