# program to write the Driver physical minimum level

import RPi.GPIO as GPIO
import time
import serial
import sys
import os

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.2,
)

serslow = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=10,
)

def ncrlf(rline):
	x = ser.read()
	if( x == 'N'):
		ser.read(1)
		return
	print('Line %d unexpected %s'%(rline,x))
	if( x != '\n'):
		x=ser.read(10)
		print('Line %d rest of input %s'%(rline,x))
	return


def GetJ(addr,why):
	x=serslow.read(1)
	y=258
	while(y==258):
		if x == 'P' :
			x=ser.read(3)
			print('              in GetJ   Power %s'%x),
			x=ser.read(3)
			print('%s'%x)
			ser.read(2)
			x=ser.read(1)
			continue
		if x == 'N' :
#			print('              in GetJ   No Response %s'%why)
			crlf=ser.read(1)
			x=ser.read(1)
			continue
		y=256

	if x == 'J' :
		y=ser.read(2)
		y=int(y,16)
		if( addr == 3):
			print('                      Address %d'%(y/2))
		if( addr == 2):
			print('                      Data %02X'%(y))
		crlf=ser.read(1)
	elif x == 'H' :
		x=ser.read(2)
		x1 = int(x,16)/2
		x=ser.read(2)
		x2 = int(x,16)
		print('               In GetJ  Address %d level %d'%(x1,x2))
		x=ser.read(1)
		y=257
	elif x == '':
		return 256
	else :
		print(' getJ got %s'%x),
	return y


def GetMemory(saddr, bank,addr,rline):
	ser.write('hC3%02X\n'%bank)
	ser.write('hA3%02X\n'%addr)
	ser.read(4)
	ser.write('h%02XC5\n'%(saddr*2+1)) # a
	x = ser.read(1)
	while(x != 'J'):
		print('GetMemory err %d %s'%(rline,x)),
		x = ser.read(1)
	if x == 'J' :
		y=ser.read(2)
		y=int(y,16)
	crlf = ser.read(1)
	return y

def SetMemory(saddr, bank,addr,data):
	ser.write('hC3%02X\n'%bank)
	ser.write('hA3%02X\n'%addr)
	ser.write('t%02X81\n'%(saddr*2+1)) # a
	ser.read(8)
	ser.write('hC7%02X\n'%data)
	ser.read(4)

def GetVolts(Min):
	ser.write("p\n")
	time.sleep(1)
	x=ser.read(1)
	Volts = 0
	while(x != 'P' and x != ''):
		print("unexpected line 111 %s"%x),
		x=ser.read(1)
	if( x == "P" ):
		x=ser.read(3)
		x=ser.read(3)
		Volts = int(x,10)
		x=ser.read(2)
		if(Volts >= Min):
			print('                      %2.1f Volts'%(Volts/10))
	return Volts  # volts x 10


def GetWatts():
	ser.write("w3\n")
	x=serslow.read(1)
	mWatts = 0
	while(x != 'W' ):
		if( x == "P" ):
			x=ser.read(3)
			x=ser.read(3)
			Volts = int(x,10)
			x=ser.read(1)
			print('          in GetWatts %2.1f Volts'%(Volts/10))
		else:
			print('GetWatts %d %s'%(rline,x)),
		x=ser.read(1)

	if( x == "W" ):
		mWatts=GetOffset()
	return mWatts


def GetOffset():
	global AOffset
	global BOffset

	x=ser.read(1)
	if( x == 'i'):
		AOffset=int(ser.read(5),10)
		BOffset=int(ser.read(5),10)
		zi=int(ser.read(5),10)
		print(' A Offset=%d B Offset=%d hours=%d\n'%(AOffset,BOffset,zi))
		mWatts=0
	else:
		y=ser.read(4)
		mWatts = int(y,10)+ int(x,10)*10000
		print('                      %d mWatts'%(mWatts))
	x=ser.read(1) # end of line

	return mWatts


def SetCCT(color,saddr):
	msbcolor = color/256
	lsbcolor = color & 255
	ser.write('h%02x03\n'%(saddr*2+1)) # no fade
	ncrlf(167)
	ser.write('hC3%02X\n'%(msbcolor))
	ncrlf(169)
	ser.write('hA3%02X\n'%(lsbcolor))
	ncrlf(171)
	ser.write('hC108\n')
	ncrlf(173)
	ser.write('h%02XE7\n'%(saddr*2+1))
	ncrlf(175)
	ser.write('hC108\n')
	ncrlf(177)
	ser.write('t%02xE2\n'%(saddr*2+1))
	ncrlf(179)
	ncrlf(180)

print('\n\n')
print('      ATX LED Consultants Inc - Fixture Physical Limits ')
print('')

print("\nStop ZWD")

os.system('sudo systemctl stop zpds.service')

x=ser.read(1)
while x != "" :
	x=ser.read(1)

ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print(' Serial Port fail \n\n')
	exit()

x=ser.read(2)
print('HW version: %s'%(x))
y=ser.read(2)
print('FW version: %s'%(y))

if( x != '05' ):  # not tester
	GPIO.setmode(GPIO.BCM)
	GPIO.setup(5,GPIO.IN)
	GPIO.setup(6,GPIO.IN)
	print(' not a tester')
	exit()

else:   # tester

	GPIO.setwarnings(False)
	GPIO.setmode(GPIO.BOARD)
	GPIO.setup(29,GPIO.OUT)
	GPIO.setup(31,GPIO.OUT)
	GPIO.setup(33,GPIO.OUT)
	GPIO.setup(37,GPIO.OUT)
	#turn power off
	GPIO.output(37,0)
	time.sleep(.25)
	GPIO.output(29,0)
	#turn relays off
	GPIO.output(31,0)
	GPIO.output(33,0)
	ser.write("w400000\n") # N-Way open

expres = 0
rbus = 0


print("\nStart DR2 Test")

x=ser.read(100)

#print('Limited')
GPIO.output(29,1) # turn low current on

VR=0
ms=0
while (VR < 350) :
	time.sleep(.05)
	ms = ms + 50
	ser.write("hFE00\n") # insure load is off
	ser.read(2)
	VR=GetVolts(250)
#print('Delay = %d'%ms)
mWatts = GetWatts()

#print('On')
GPIO.output(37,1) # turn high current on

VR=0
ms=0
while (VR < 470) :
	time.sleep(.05)
	ms = ms + 50
	VR = GetVolts(470)
#print('Delay = %d'%ms)

ser.write("w7\n")  # check the calibration
x=ser.read(1)
volts = 0
while(x != 'W' ):
	print("%s"%x),
	x=ser.read(1)
if( x == "W" ):
	GetOffset()

ser.write("hFE00\n")
ser.read(100)
ser.write("hFF90\n") # anyone there?
x=GetJ(1,"")
if( x == 256 ):
	print('no device attached')

ser.write("hFF96\n") # address assigned already?
x=GetJ(1,"")
if (x == 256 ) :
	print('Address assigned'),
	print('removing SA')
	ser.write("hA3FF\n") # Load DTR with FF
	ser.write("tFF80\n") # address set to 255
	x=ser.read(6)
	time.sleep(1)
else:
	print('no address assigned')
ser.write("hA321\n") # Load DTR with 16
ser.write("tFF80\n") # address set to 16
address = 16
time.sleep(2)
x=GetJ(1,"")
ser.write("hFF96\n") # address assigned already?
x=GetJ(1,"verify SA")
if (x == 256 ) :
	print('Address assigned')
else:
	print('error')

x=ser.read(1000)

value = GetMemory(address,5,80,302)
SetMemory(address,5,80,value)
value = GetMemory(address,5,81,304)
SetMemory(address,5,81,value)


print(" Set Right then Left, 680 is max ")

SetMemory(address,5,9,3)  # CCT

SetCCT(353,address) # warm

ser.write('h%02X03\n'%(address*2+1)) # break Fade
ser.write('h%02X05\n'%(address*2+1)) # set max bright
ser.read(2)

delay = 0
while(delay < 5 and mWatts < 24000):
	mWatts = GetWatts()
	delay = delay+1
	time.sleep(1)


text = "l"

while text != "" :
	value = GetMemory(address,5,80,328)

	mWatts = GetWatts()

	text = raw_input('now: %d Enter Phy Right , blank for Left/Cool : '%(value*4) )
	if(text == "" ):
		break
	ser.read(10000)
	newphy = int(text) / 4

	SetMemory(address,5,80,newphy)

	time.sleep(.5)
	

SetCCT(0,address) # cool

text = "r"
while text != "" :

	value = GetMemory(address,5,81,348)

	mWatts = GetWatts()

	text = raw_input('now: %d Enter Phy Left , q to end : '%(value*4) )
	if(text == "" ):
		break
	if(text == "q"):
		break
	ser.read(10000)
	newphy = int(text) / 4

	SetMemory(address,5,81,newphy)

	time.sleep(.5)
	

if(text == 'q'):
	GPIO.output(37,0)
	time.sleep(.25)
	GPIO.output(29,0)
	#turn relays off
	GPIO.output(31,0)
	GPIO.output(33,0)
	ser.write("w400000\n") # N-Way open
	exit()

# now cycle until ^C

print('Now Cycle Min / Max until ^C exit')

while 1 :
	ser.write('h%02X06\n'%(address*2+1))
	time.sleep(1)
	ser.write('h%02X05\n'%(address*2+1))
	time.sleep(1)

