#
# program to stress test the DALI bus
# loop from 0-63 to get on/off/level and dali type
#

import RPi.GPIO as GPIO
import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.25,
)

bus = 1

retchar =1

def ReadByte(cmd, dadd):
        ser.write('h%02X%02X\n'%(dadd*2+1,cmd))
        x=ser.read(1)
        if(x == 'J'):
                byte = int(ser.read(2),16)
                ser.read(1)
                return byte
        ser.read(10)
        return -1

def SetBank(DTR1, DTR):
        global bus
        global index
        if( bus > 0) :
                ser.write('%dhC3%02X\n'%(bus,DTR1))
                x=ser.read(3)
                ser.write('%dhA3%02X\n'%(bus,DTR))
                x=ser.read(3)
        else :
                ser.write('hC3%02X\n'%DTR1)
                x=ser.read(2)
                ser.write('hA3%02X\n'%DTR)
                x=ser.read(2)
        index = DTR
        return

def serchannel():
	global bus
	x = ser.read(1)
	bus = 1
	if x == '1' :
		bus = 2
		x=ser.read(1)
	if x == '2' :
		bus = 3
		x=ser.read(1)
	if x == '3' :
		bus = 4
		x=ser.read(1)
	return x

def RetchF():
	global retchar
	if(retchar) :
		print('\n'),
		retchar=0
	return

def ReadPhy(address):
	z=ser.read(10)
	packet = 0
	while packet < 16 :
		SetBank(6,packet*4)
		bits  = ReadByte(0xC5,address)
		if(bits == -1) :
			break;
		D0  = ReadByte(0xC5,address)
		D1  = ReadByte(0xC5,address)
		width  = ReadByte(0xC5,address)
		print(' bits = %2d, D0 = %02x, D1 = %02x, width %2d count %2d'%(bits,D0,D1,packet,width))
		packet += 1
	if(bits != -1):
		bits  = ReadByte(0xC5,address)
		print(' last Index %2d'%bits)
	return 


x=ser.read(1000)

last=0

print('\n      ATX LED Consultants Inc - DALI read/write DTR 255x \n')

ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print('  Serial Port Conflict  \n')
	exit()

x=ser.read(2)
print('HW version: %s'%(x))
y=ser.read(2)
fwv = int(y,10)
print('FW version: %s'%(y))
hwtype=0
y=ser.read(2)
if y != "\n" :
	hwtype=int(y,10)

if hwtype == 2 :
	print('AL-DALI-Hat: 2 Channel Isolated no power')
elif hwtype == 4 :
	print('AL-DALI-Hat: 4 Channel Isolated no power')
else :
	print('AL-DALI-Hat: %d'%hwtype)

address = 16
if(len(sys.argv) > 1) :
	address = int(sys.argv[1])

ser.read(100)
done=0

bus=0
a=0
exist = range(64)

while a < 64 :
	exist[a] = 2
	a += 1

while ( address < 64 and done == 0):

	if(exist[address]==0):
		address += 1
		continue

	a = ( address * 2 ) + 1
	loop = 0
	matcherr =0
	errors = 0
	sense = 0
	while(loop < 255 and sense < 4 and done==0) : # each addr 100x
		time.sleep(.05)
		ser.write('hA3%02X\n'%(loop&255)) # write DTR
		nc=ser.read(2)
		ser.write('h%02X98\n'%(a)) # read DTR
		x=ser.read(1)
		if x == 'H' :
			data=ser.read(5)
			print('other bus data %s:H%s'%(bus,data)),
			retchar=1
		if x == 'N' :
			errors += 1 # no response
			sense += 1
			crlf = ser.read(1)
			if(sense > 4):
				print('dead air %d %s'%(address,crlf)),
			retchar=1
			x=ser.read(1) # delayed J response?
			if(x != ""):
				y=ser.read(10) # delayed J response?
				RetchF()
				print(' %d delayed response %s%s '%(address,x,y)),
				retchar=1
			else:
				ser.write('h%02X98\n'%(a))
				x=ser.read(1) # read again
				if(x != 'J'):
					ser.read(10)
		if x == 'J' :
			sense = 0
			dtr=int(ser.read(2),16) # read DTR
			crlf=ser.read()
			if((loop&255) != dtr) :  # bad write
				print('%2d DTR-soll= %3d DTR-ist= %3d'%(address,loop,dtr))
				matcherr += 1
				retchar=1
				checkall = 0
				done = 0
				tested = 0
				while(checkall < 64): # just one or many
					if( exist[checkall] > 0):
						ser.write('h%02X98\n'%(checkall*2+1)) # read DTR
						resp = ser.read(1)
						if(resp != 'J'):
							exist[checkall]=0
						else:
							dtr = int(ser.read(2),16)
							exist[checkall]=1
							tested += 1
							if(loop != dtr and checkall != address ):
								print(' Addr %2d failed also got %3d not %3d'%(checkall,dtr,loop))
						crlf=ser.read(1)
					checkall += 1
				print('tested %2d other clients'%tested)
			loop += 1
	if(sense != 4) : # 4x dead in a row 

		if(errors == 0 and matcherr == 0):
			print ('%2d OK'%address),
			retchar = 1
		else :
			RetchF()
			print('Address %2d Read Error count = %2d Write Error count = %2d '%(address,errors,matcherr))
			ReadPhy(address)
	address += 1
	if( address % 10 == 0) :
		RetchF()

print('\n done \n')
