#!/usr/bin/python
# send DALI color comamnds as API using args
# CLI is aallcccc:  address(2h), level(2h), color (4h)
# run the Monitor program to observe the response 

import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)

serfast = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.1,
)


text = sys.argv[1]

uppermsg = text.upper()

if len(uppermsg) != 8 :
	print('wrong string length')
	exit() 

SA2 = uppermsg[0:2]
SA2i = int(SA2,16)+1
#SA2i = SA2i + 1
level = uppermsg[2:4]
intl = int(level,16)
msbcolor = uppermsg[4:6]
lsbcolor = uppermsg[6:8]

color = int(msbcolor,16)*256+int(lsbcolor,16)

print('add %d level %d color %d '%(SA2i/2,intl,color))

ser.read(1000)
ser.write('hC3%s\n'%(msbcolor))
ser.read(2)
ser.write('hA3%s\n'%(lsbcolor))
ser.read(2)
ser.write('hC108\n')
ser.read(2)
ser.write('h%02XE7\n'%(SA2i))
ser.read(2)
ser.write('hC108\n')
ser.read(2)
ser.write('h%02XE2\n'%(SA2i))
ser.read(2)
time.sleep(.1)
if int(level,16) > 0 :
	ser.write('h%s%s\n'%(SA2,level))
	ser.read(2)

log = open("/home/pi/al-dali-pi/DALI/DALI_log.txt","r")
last_line = log.readlines()[-1]
log.close()

print ('%s' % last_line)

	
