#!/usr/bin/python
#
#
# program to monitor the DALI bus and report status
# displays the traffic on the DALI Bus
# 

import RPi.GPIO as GPIO
import time
import datetime
import serial

ProgTimes = [ 0, 7, 10, 14, 20, 28, 40, 56, 80, 113, 160, 226, 320, 452, 640, 900 ]

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)

serfast = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.2,
)


# program to monitor and print out all DALI bus traffic.

volts=""
voltsd=""
need130=0
need65=0
localOver=0

serfast.read(1000)

print('\n\n')
print('      ATX LED Consultants Inc - DALI bus debugger')
print('')
ser.write('v\n')  # lets get version number first
x=serfast.read()
if x == "" :
	print(' Serial Port not configured \n\n')
	exit()

x=ser.read(2)
hw=0
if x != "" :
	hw=int(x,10)
print('AL-DALI-Hat: HW version: %d'%(hw))

y=ser.read(2)
print('AL-DALI-Hat: FW version: %s'%(y))
fwver = int(y,10)

hwtype=0
y=serfast.read(2)
if y != "\n" :
	hwtype=int(y,10)
	y=serfast.read(1)

if hwtype == 2 :
	print('AL-DALI-2I: Isolated no power\nChannels:  2')
elif hwtype == 4 :
	print('AL-DALI-4I: Isolated no power\nChannels:  4')

elif hwtype == 1 :
	print('AL-DALI-Hat: with power v2 \nChannels:   1')

else :
	print('AL-DALI-Hat: %d'%hwtype )


if(fwver > 4 ) :
	ser.write('s\n')  # lets get String data
	x=serfast.read(1)
	x=serfast.read(100)
	if x == "\n" :
		print('Key String: empty')
	else :
		print('Key String: content: %s'%(x))

print('')
print('Destination <= Data ')
print('        Axxx = Short Address')
print('        Gxx  = Group Address')
print('        All  = Broadcast')
print('')
print('B Date Time    Data')
print('')

ser.write('p\n')  # now check if Power is good

nl = 0
DT = 0
DT1 = 0
DT2 = 0

log = open("DALI_log.txt","a+")

FlushFlag = 0

PacketCount=0;
PacketTime=0;
ts1 = 0
Once0 =0
Once1 =0
Once2 =0
Once3 =0
Search =0

Cmd = "start"

while 1:
	ch=1
	x=ser.read(1)
	ts = time.time()
	
	if x == '1' :
		x=ser.read(1)
		ch = 2
	if x == '2' :
		x=ser.read(1)
		ch = 3
	if x == '3' :
		x=ser.read(1)
		ch = 4
	if x == 'L':
		x=ser.read(7)
		print("%d 24 bit command %s"%(ch,x))
	if x == 'H' :
		if( Cmd != ""):
			print('%1d'%(ch)),
		PacketCount = PacketCount+2
		PacketTime = PacketTime + 25
		if ts1 == 0 :
			ts1 = time.time()

		st = datetime.datetime.fromtimestamp(ts).strftime('%d %H:%M:%S ')
		if( Cmd != "" ) :
			print st,
		if nl != 0 :
			print('%3d nak'%(nl))
			nl = 0
		x=ser.read(2)
		x=int(x,16)
		yt=ser.read(2)
		y=int(yt,16)

		if ( x & 1 )== 0 :  # arc command
			if x & 128 == 0 :
				print('A%2d <= level %3d'%(x/2,y))
				log.write('%s : A%2d <= level %3d'%(st,x/2,y))
			if x & 192 == 128 :
				print('G%2d <= level %3d'%(x/2-64,y))
				log.write('%s : A%2d <= level %3d'%(st,x/2-64,y))
			if x == 254 :
				print('all <= level %3d'%(y))
				log.write('%s : All <= level %3d'%(st,y))
			x=ser.read(1)
		else:
			Cmd = "Command %3d" % y
			if DT < 16:
				Time = ProgTimes[DT]

			if y == 0:
				Cmd = "Off"
			if y == 6:
				Cmd = "Set to Min level"
			if y == 5:
				Cmd = "Set to Max level"
			if y == 35:
				Cmd = "Set Mode to %d " % (DT)
			if y == 42:
				Cmd = "Set Max Level to %d" % (DT)
			if y == 43:
				Cmd = "Set Min Level to %d" % (DT)
			if y == 44:
				Cmd = "Set System Failure Level to %d" % (DT)
			if y == 45:
				Cmd = "Set Power On Level to %d" % (DT)
			if y == 46:
				Cmd = "Set Fade Up %d seconds " % (Time)
			if y == 47:
				Cmd = "Set Fade Down %d seconds" % ( Time )
			if y == 49:
				Cmd = "UPS Mode - Temporary Max Light %d pct " % (DT*100/254)
			if y == 50:
				Cmd = "Fan Idle speed %d pct " % (DT*100/254)
			if y == 51:
				if(DT) :
					Cmd = "Fan Delay %d seconds" % ( DT*4 )
				else :
					Cmd = "Fan Delay disabled "
			if y == 52:
				if(DT) :
					Cmd = "Fan Hold %d seconds" % ( DT*16 )
				else :
					Cmd = "Fan disabled "
			if y == 53:
				Cmd = "Fan Speed %d pct " % (DT*100/255)
			if y > 95 :
				if y < 112 :
					Cmd = "Add to Group %d" % (y-96)
			if y > 111 :
				if y < 128 :
					Cmd = "Remove from Group %d" % (y-112)
			if y == 129:
				Cmd = "Enable Memory Write"
			if y == 144:
				Cmd = "Query Status"
			if y == 145:
				Cmd = "Ping Driver"
			if y == 148:
				Cmd = "Query Range Error"
			if y == 152:
				Cmd = "Query DT Reg"
			if y == 153:
				Cmd = "Query DALI type"
			if y == 155:
				Cmd = "Query power failure"
			if y == 156:
				Cmd = "Query DT Reg 1"
			if y == 160:
				Cmd = "Query Arc Level"
			if y == 161:
				Cmd = "Query Max Level"
			if y == 162:
				Cmd = "Query Min Level"
			if y == 163:
				Cmd = "Query Power On Level"
			if y == 171:
				Cmd = "Query AL-WS-010v"
			if y == 192:
				Cmd = "Query Group 0-7"
			if y == 193:
				Cmd = "Query Group 8-15"
			if y == 197:
				Cmd = "Read Memory at %d : %d"%(DT1,DT)
				DT = DT+1
			if y == 226:
				Cmd = "Activate Color"
			if y == 231:
				w = 5000 -  ( DT1 * 256 + DT ) * 6.5
				Cmd = "Set Color temp to %4d K " % (w)
			if y == 250:
				Cmd = "Read Color, load DTReg"

			z = x/2+176

			Address = "ALL"
			if x & 128 == 0 :
				print('A%2d <= %s '%(x/2,Cmd))
				log.write('%s : A%2d <= %s'%(st,x/2,Cmd))
				Address = 'A%2d => '%(x/2)

			if x & 224 == 128 :
				print('G%2d <= %s '%(x/2-64,Cmd))
				log.write('%s : G%2d <= %s'%(st,x/2-64,Cmd))
				Address = 'G%2d => '%(x/2-64)

			if x & 224 == 160 :
				Cmd = "all <= Send command %3d data %3d " % (z,y)

				if z == 256:
					Cmd = "Terminate Addressing mode"

				if z == 257:
					Cmd = "all <= Load DT  Register with %3d "%(y)
					DT = y
				if z == 258:
					Cmd = "Initialize Addressing mode %02x"%y

				if z == 259:
					Cmd = "Randomize Addressing mode"

				if z == 260 :
					Cmd = "Compare with %06X " % (Search)
				if z == 261 :
					Cmd = "Withdraw %06X " % (Search)
				if z == 264 :
					Cmd = ""
					Search = Search & 0x00FFFF | y << 16
				if z == 265 :
					Cmd = ""
					Search = Search & 0xFF00FF | y << 8
				if z == 266 :
					Cmd = ""
					Search = Search & 0xFFFF00 | y
				if z == 267:
					Cmd = "%3d <= Set Short Address "%(y/2)

				if z == 269:
					Cmd = "Query Short at %06X "%(Search)

				if Cmd != "" :
					print('%s '%(Cmd))
					log.write('%s : %s'%(st,Cmd))

			if x & 224 == 192 :

				Cmd = 'all <= Command %3d data %3d '%(z,y)

				if z == 272 :
					Cmd = 'all <= Enable Device Type %3d'%(y)

				if z == 273 :
					Cmd = 'all <= Load DT1 Register with %3d '%(y)
					DT1 = y

				if z == 274 :
					Cmd = 'all <= Load DT2 Register with %3d '%(y)
					DT2 = y

				if z == 275:
					Cmd = 'all <= Write %3d to Memory at %3d:%3d'%(y,DT1,DT) 

				if z == 276:
					Cmd = 'all <= Write %3d to Memory at %3d:%3d'%(y,DT1,DT)

				print("%s"%Cmd)
				log.write('%s : %sd'%(st,Cmd))

			if x == 255 :
				print('all <= %s '%(Cmd))
				log.write('%s : all <= %s'%(st,Cmd))

		log.write('\r\n')
		FlushFlag = 11

	if x == 'D' :
		print('%1d'%(ch)),
		st = datetime.datetime.fromtimestamp(ts).strftime('%d %H:%M:%S ')
		print st,
		if nl != 0 :
			print('%3d nak '%(nl)),
			nl = 0
		y=ser.read(1)
		if hwtype == 2:
			if Once0 == 0 :
				Once0=1
				ser.write('1d\n')
		if hwtype == 4 :
			if Once1 == 0 :
				Once1 = 1
				ser.write('2d\n')
			else :
				if Once2 == 0 :
					Once2 = 1
					ser.write('3d\n')
				else :
					if Once3 == 0 :
						Once3 = 1

		if y == '0' :
			print('DALI BUS: power is lost '),
		if y == '1' :
			print('DALI BUS: power is stuck high '),
		if y == '2' :
			print('DALI BUS: power is good '),
		if y == '3' :
			print('DALI BUS: power is not yet known '),
		if y == '4' :
			print('DALI BUS: voltage too high '),
		x=serfast.read(1)
		print('%1d of'%ch),
		mA=""
		if x == '1' :
			print('1 Channel')
		if x == '2' :
			print('2 Channels')
		if x == '4' :
			print('4 Channels')

		log.flush()
		if hwtype == 1 :
			ser.write('q\n')

	if x == 'Q' :
		print('%1d'%(ch)),
		st = datetime.datetime.fromtimestamp(ts).strftime('%d %H:%M:%S ')
		print st,

		if nl != 0 :
			print('%3d nak '%(nl)),
			nl = 0

		y=ser.read(1)
		y=int(y,10)
		if y > 3 :
			print('DALI BUS: auto current disabled')
		else :
			print('DALI BUS: auto current enabled')
		y &= 3
		print('              '),

		if y == 0 :
			print('DALI BUS: internal power disabled '),
			localDALI=0
		if y == 1 :
			print('DALI BUS: internal power enabled with 65 mA '),
			localDALI=1
		if y == 2 :
			print('DALI BUS: unknown '),
			localDALI=2
		if y == 3 :
			print('DALI BUS: internal power enabled with 200 mA '),
			localDALI=3
		if need130 > 0 :
			print(' DALI BUS: load > 130 mA'),

		volts=ser.read(2)
		volts=int(volts,10)
		if volts < 12 :
			if volts > 5 :
				need130 += 1
			else :
				need65 = 1

		mvolts=ser.read(3)
		print('\n               DALI Bus idle is %d.%3s V'%(volts,mvolts))
		mA0=serfast.read(3)
		mA0=int(mA0,10)
		print('               %1d mA at 0 volts,'%(mA0)),
		mA5=serfast.read(4)
		mA5 = int(mA5,10)
		print('%d mA at 12 volts'%(mA5)),
		mA5f=serfast.read(3)
		mA5f = int(mA5f,10)
		x=serfast.read(1)
		print('%d mA at 6 volts'%(mA5f))
#		print('\n               need65=%d need130=%d localDALI=%d'%(need65,need130,localDALI))
		sent=0
		if mA5 > 130 :
			if need65 == 1 :
				need65 = 0
		if mA5 > 170 :
			if need130 == 0 :
				if localDALI > 0 :
					ser.write('q0\n')
					print("q0\n")
					localDALI=0
					sent = 1
		if  sent == 0 :
			if need65 == 1 :
				if volts < 12 :
					if localDALI == 0 :
						ser.write("q1\n")
						localDALI=1
						sent = 1
		if sent == 0 :
			if need130 > 0 :
				if volts < 12:
					if localDALI == 0 :
						ser.write("q1\n")
						localDALI=1
					if localDALI == 1 :
						if localOver == 0 :
							ser.write("q3\n")
							localDALI=3
				else :
					if mA5 > 260 :
						if localDALI == 3:
								ser.write("q1\n")
								localDALI=1
								localOver=1
						if localDALI == 1:
								ser.write("q0\n")
								localDALI=0

#		print('\n               need65=%d need130=%d localDALI=%d'%(need65,need130,localDALI))

		log.write('%s : DALI Power => %s %s.%s %s\r\n'%(st,y,volts,mA0, mA5))
		log.flush()

	if x == 'N' :
		print('.'),  # normal: no response to most commands, just a dot
		nl = nl + 1
	if x == 'J' :
		print('%1d'%(ch)),
		PacketCount = PacketCount+1
		PacketTime = PacketTime + 13
		st = datetime.datetime.fromtimestamp(ts).strftime('%d %H:%M:%S ')
		print st,
		if nl != 0 :
			print('%3d nak'%(nl))
			nl = 0
		y=ser.read(2)
		y=int(y,16)
		if( y == 255 ) :
			print('                      Yes / All')
		else :
			if( (y & 1) and (y < 128)) :
				print('%s          Answer %02x Hex %d Decimal %d Address '%(Address,y,y,y/2))
			else :
				print('%s          Answer %02x Hex %d Decimal'%(Address,y,y))
		log.write('%s : %s        Response %d\r\n'%(st,Address,y))
		FlushFlag = 2
	if x == 'X' :
		print('%1d'%(ch)),
		st = datetime.datetime.fromtimestamp(ts).strftime('%d %H:%M:%S ')
		print st,
		if nl != 0 :
			print('%3d nak'%(nl))
			nl = 0
		print(' Receive Collision')
		log.write('%s : Receive Collision \r\n'%(st))
		FlushFlag = 3

	if x == 'Z' :
		print('%1d'%(ch)),
		st = datetime.datetime.fromtimestamp(ts).strftime('%d %H:%M:%S ')
		print st,
		if nl != 0 :
			print('%3d nak'%(nl))
			nl = 0
		print('Xmit Collision')
		log.write('%s : Xmit Collision \r\n'%(st))
		FlushFlag = 3

	if x == 'P' :
		st = datetime.datetime.fromtimestamp(ts).strftime('  %d %H:%M:%S ')
		print st,
		y=ser.read(2)
		y=int(y,10)
		x=ser.read(1)
		if hwtype == 1 :
			print('Primary %3d.%s Volts,'%(y,x)),
		y1=ser.read(2)
		y1=int(y1,10)
		x1=ser.read(1)
		if hwtype == 1 :
			print(' Secondary %3d.%s Volts, '%(y1,x1)),
		s=ser.read(1)
		if s == '0' :
			print('Switch is Off ')
		else :
			print('Switch is On ')
		log.write('%s : Voltage Change %d%s %d%s Switch %s\r\n'%(st,y,x,y1,x1,s))
		FlushFlag = 3
		ser.write('d\n')  # now check DALI Power

	if x == 10 :
		print('newline')

	if x == '' :
		if(PacketCount > 20) :
			lt = ts-ts1
			st = datetime.datetime.fromtimestamp(lt).strftime('%M minutes %S seconds ')
			Eff = (PacketTime*100) / (lt*1000)
			print('last burst was %d packets in %s = %d pct utilization '% ( PacketCount/2,st,Eff) )
		if PacketCount > 0  :
			PacketCount = 0
			PacketTime = 0
			ts1 = 0

	if FlushFlag > 0 :
		FlushFlag -= 1
		if FlushFlag == 1 :
			log.flush()
			
