#!/usr/bin/python
# program to monitor the DALI bus and report status
# displays the traffic on the DALI Bus
# 

import RPi.GPIO as GPIO
import time
import datetime
import serial

ProgTimes = [ 0, 7, 10, 14, 20, 28, 40, 56, 80, 113, 160, 226, 320, 452, 640, 900 ]

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=100,
)

serfast = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.2,
)


# program to monitor and print out all DALI bus traffic.


print('\n\n')
print('      ATX LED Consultants Inc - DALI bus debugger')
print('')
ser.write('v\n')  # lets get version number first
x=serfast.read()
if x == "" :
	print('  Serial Port Conflict  \n\n')
	exit()

x=ser.read(2)
hw=0
if x != "" :
	hw=int(x,10)
print('AL-DALI-Hat: HW version: %d'%(hw))

y=ser.read(2)
fwver = int(y,10)
print('AL-DALI-Hat: FW version: %d'%(fwver))

hwtype=0
y=serfast.read(2)
if y != "\n" :
	hwtype=int(y,10)

if hwtype == 2 :
	print('AL-DALI-2I: 2 Channel Isolated no power')
elif hwtype == 4 :
	print('AL-DALI-4I: 4 Channel Isolated no power')

elif hwtype == 1 :
	print('AL-DALI-Hat: single channel V2')

else :
	print('AL-DALI-Hat: %d'%hwtype)

if(fwver > 4 ) :
	x=serfast.read(100)
	ser.write('s\n')  # lets get String data
	x=serfast.read(1)
	x=serfast.read(100)
	if x == "\n" :
		print('AL-DALI-Hat: String empty')
	else :
		print('AL-DALI-Hat: String content: %s'%(x))

print('')
print('Destination <= Data ')
print('        Axxx = Short Address')
print('        Gxx  = Group Address')
print('        All  = Broadcast')
print('')

ser.write('p\n')  # now check if Power is good
x=serfast.read(10)
print x


ser.write('d\n')  # now check if Power is good
if hwtype > 1 :
	ser.write('1d\n')  # now check if Power is good
if hwtype > 2 :
	ser.write('2d\n')  # now check if Power is good
	ser.write('3d\n')  # now check if Power is good


while 1:
	x=ser.read(1)
	print x,
	if x == 'P' :
		ser.write('q\n')
