# DALI Current supply from the Hat
# change and query the different settings

import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.5,
)

x=ser.read(1000)
ser.write('q\n')  # write qXXYY where XX is the first DALI byte
time.sleep(2)
x=ser.read(1)
print('\n\n DALI POWER REPORT')
print('\n user can set Onboard Supply:')

while 1 :
	if x == "" :
		print(' Change Current: 0= Off, 1= add 80 mA, 3= add 180 mA, \n 4= auto, 5= lock, 6=status, d=full test, q=quit')
		message = raw_input("input command (0,1,3,4,5,6,d,r,q) : ")  # enter 1 character
		x=ser.read(1000)
		if message == 'q' :
			exit()
		if message == 'd' :
			ser.write('q\n')  # retest the bus
			time.sleep(2)
		else :
			ser.write('q%s\n'%(message))  # write q function
		x=ser.read(1)

	if x == 'H' :
		x=ser.read(4)
		print('bus data H%s'%(x))
		crlf=ser.read(1)

	if x == 'J' :
		y=ser.read(2)
		y=int(y,16)
		print('                      Answer %02x'%(y))
		crlf=ser.read(1)

	if x == 'X' :
		print('Framing Error')
		crlf=ser.read(2)

	if x == 'Z' :
		print('Collision')
		crlf=ser.read(1)

	if x == 'D' :
		print(' DALI Status'), 
		x=ser.read(1)
		number=ser.read(1)
		crlf=ser.read(1)
		if x == '0' :
			print('No DALI bus Power')
		if x == '1' :
			print('DALI bus stuck high')
		if x == '2' :
			print('DALI bus Power OK')
		ser.write('q\n')  # get power 
		time.sleep(2)
	if x == 'P' :
		print(' Supply Power'), 
		x=ser.read(2)
		y=ser.read(1)
		print('        Input A %s.%s V,'%(x,y)),
		x=ser.read(2)
		y=ser.read(1)
		print(' Input B %s.%s V,'%(x,y)),
		x=ser.read(1)
		if x == "1" :
			print(' Switch On')
		else :
			print(' Switch Off')
		crlf=ser.read(1)
		print ('\n')

	if x == 'Q' :
		print('\n Dali Power: '),
		y=ser.read(1)
		x = int(y,10)
		locked = "Auto"
		if x > 3 :
			x = x & 3
			locked = "locked"
		if x == 0 :
			mode = "Off"
		if x == 1 :
			mode = "80 mA"
		if x == 3 :
			mode = "180 mA"
		print(' Onboard Supply is %s and %s'%(mode,locked))
		x=ser.read(5)
		x=int(x,10)
		print(' DALI Bus= %d mV,'%(x)),
		x=ser.read(3)
		x=int(x,10)
		print('%d mA at 0 Volts,'%(x)),
		x=ser.read(4)
		x=int(x,10)
		print('%d mA at 12 Volts,'%(x)),
		x=ser.read(4)
		x=int(x,10)
		print('%d mA at 6 Volts'%(x))
		ser.write('p\n')  # get power 
		crlf= ser.read(1)

	x=ser.read(1)
