#
#
# program to find Group members
# scan all groups
# optionally scan for the members of one group
#


import time
import serial
import sys 

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)
serfast = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.2,
)


print('\n      ATX LED Consultants Inc - Read and Set Group\n')

ser.write('d\n')  # now check if Power is good
x=ser.read(1)
if x == '' :
	print('  Serial Port Conflict  ')
	exit()
if x == 'D' :
	y=ser.read(2)
	y=int(y,16)
	if y == 0 :
		print('DALI BUS: power is lost')
	if y == 1 :
		print('DALI BUS: power is stuck high')
	if y == 2 :
		print('DALI BUS: power is good')
	if y == 3 :
		print('DALI BUS: power is not yet known')

print(' ')
x=ser.read(10)

if( len(sys.argv) == 2 ):
	group = int(sys.argv[1])
	count = group + 1
else :
	group = 0
	count = 16

while group < count :

# look for full DALI configurable

	print(' Test Group %2d ' % group ), 

	ser.write('h%02x91\n'%(group*2+129))
	x=ser.read(1)
	if x == 'J' :
		x=ser.read(2)
		print('         Members(s) found '),
	if x == 'D' :
		x=ser.read(2)
		print('Multiple members    found '), # bus crash
		x=ser.read(10)
		ser.write('hA300\n')   # clean up bus
		x=ser.read(1)
	if x == 'X' :
		print('Multiple members    found '),
		serfast.read(5)
#	if x == 'N' :
#		print('No       members in ')
	time.sleep(.3)

	x=serfast.read(1)
	if x == 'D' :
		x=serfast.read(15)  # bus back
		print('D response %2s' % x)


# look for hard wired AL-WS-010v or 8B passive

	x=serfast.read(10)

	ser.write('h%02xAB\n'%(group*2+129)) # 0-10v type
	x=ser.read(1)
	if x == 'J' :
		x=int(ser.read(2),16)
		crlf=ser.read(1)
		ser.write('h%02xAC\n'%(group*2+129))  # multiswitch type
		x=ser.read(1)
		if x == 'J' :
			x=int(ser.read(2),16)
			print('         Passive found in group with Owner %d'%x),
		else : # no response - unknown owner
			print('         Passive found in group'),

	if x == 'D' :
		x=ser.read(2)
		print('         Multiple Passive found '), # bus crash
		x=ser.read(10)
		ser.write('hA300\n')  # clean up bus
		x=ser.read(1)
	if x == 'X' :
		print('         Multiple Passive found '),
		serfast.read(5)
	time.sleep(.3)

	x=serfast.read(1)
	if x == 'D' :
		x=serfast.read(15)  # bus back
		print('D response %2s' % x)

	print('')
	group = group + 1
	time.sleep(.2)

text = 'A'

while text != 'q' :

	text = raw_input("Search members in Group ( 0-15 ) q is Exit : ")
	if text != 'q' :
	
		group = int(text)

		sa=0
		gread = "C0"
		bit = 1 << ( group & 7)
		if group > 7 :
			gread = "C1"

		found = 0

		while sa < 64 :

			ser.write('h%02x%s\n'%(sa*2+1,gread))
			x=ser.read(1)
			if x == 'D' :
				x=ser.read(2)
				print('DALI power up/down %2s' % x)
			if x == 'J' :
				text=ser.read(2)
				response = int(text,16)
				if response & bit :
					print('   Address %d is a member'% (sa) )
					found = 1
			if x == 'X' :
				type = ser.read(1)
				print('   Collision %d '% (sa) )
			cr=ser.read(1)

			ser.write('h%02xAC\n'%(sa*2+1))
			y=ser.read(1)
			if y == 'J' :
				text=ser.read(2)
				response = int(text,16)
				print('   Owner %d has a passive individual(not group) at SA %d '% (response,sa) )
				found = 1
			if( y == 'X' ):
				type=ser.read(1)
				print('   Multiple Passive Owners' )
				found = 1

			cr=ser.read(1)
			sa = sa+1
			time.sleep(.05)

		if found == 0 :
			print(' no members ')

		print(' ')

