# DALI HAT Translation TOol

import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.1,
)

def DecodeAdd(Raw,Hex):
	i = int(Raw,Hex)
	Result = Raw
	if(i < 64 ):
		Result = "SA %2d"%i
	elif(i < 80):
		Result = "Group %2d"%(i&15)
	elif(i < 96 ):
		Result = "Trigger %2d"%(i&15)
	elif(i < 224 ):
		Result = "Scene %2d"%(i&15)
	return Result


ser.write('q\n')  # write qXXYY where XX is the first DALI byte
print('\n\n DALI HAT translation read/write')

x=ser.read(2)
x=ser.read(10000)

len = 1
notempty=0

while 1 :
	if x == "" :
		print('\n\n Set/Read Translate Table')
		print('\n Read, Write, Erase, Clear All, Quit')
		message = raw_input("input command (r,w,e,c,q) : ")  # enter 1 character
		ser.read(10000)
		if message == 'q' :
			exit()
		if message == 'r' :
			i=0;
			found=0
			while( i < 32):
				ser.write('f%02x\n'%i)  # read
				x=ser.read(1)
				while(x != 'F'):
					x=ser.read(1)
				ser.read(2)
				w=ser.read(2)
				x=ser.read(2)
				xd = DecodeAdd(x,16)
				xi=int(x,16)
				y=ser.read(2)
				yi=int(y,16)
				Reverse = yi/128
				z=ser.read(2)
				zd = DecodeAdd(z,16)
				crlf=ser.read(2)
				if(w != "FF"): 					
					print("\n[ %2d ] ch %s %s ch %02d %s"%(i,w,xd,yi&3,zd)),
					if( Reverse ):
						print(" reciprocal "),

					found = 1
					notempty = 1
				else :
					if(notempty):
						print("\n[ %2d ] empty "%(i)),
						notempty=0

				i = i+ 1
			if(found == 0) :
				print('\nNo Records'),


		if message == 'e' :
			message = raw_input("Erase Entry # : ")  # 
			ENum = int(message,10)
			ser.write('f%02xFF345678\n'%(ENum))  # erase
			time.sleep(2)
			x=ser.read(10)
			print("...%s..."%x)
		if message == 'c' :
			i=0
			while( i<32):
				ser.write('f%02xFF345678\n'%(i))  # erase
				time.sleep(1)
				i = i + 1
			time.sleep(2)
			x=ser.read(1000)
			print("...%s..."%x)
		if message == 'w' :
			message = raw_input("input Entry # : ")  # 
			ENum = int(message,10)

			message = raw_input("input Source Channel : ")  # 
			chI = int(message,10)
			message = raw_input("input Source Add : ")  # 
			AddI = int(message,10)
			Addd = DecodeAdd(message, 10)
			print(" %s"%Addd)

			message = raw_input("input Dest Channel : ")  # 
			chD = int(message,10)
			message = raw_input("input Dest Add : ")  # 
			AddD = int(message,10)
			Addd = DecodeAdd(message, 10)
			print(" %s"%Addd)

			if( AddI&0xf0 == 80 ):
				message = raw_input("Forward as Scene y/n : ")  # 
				if(message == 'y'):
					AddD = AddD + 128


			message = raw_input("Reciprocal y/n : ")  # 
			if( message == 'y'):
				chD = chD+ 128

			ser.write('f%02x%02x%02x%02x%02x\n'%(ENum,chI,AddI,chD,AddD))  # write
			time.sleep(2)
			x=ser.read(10)
			print("%s"%x)
	else :
		print("%s"%x),

	x=ser.read(1)