#
# allow the error offset correction to be adjusted in a hat
#

import time
import serial
import sys
import RPi.GPIO as GPIO
import os

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.5,
)

def GetOffset(AorB):
	global BOffset

	x=ser.read(1)
	if ( x != 'i') :
		return

	xi=int(ser.read(5),10)
	if(xi > 30000) :
		xi = 32767-xi
	BOffset=int(ser.read(5),10)
	if(BOffset > 30000) :
		BOffset = 32767-BOffset
	zi=int(ser.read(5),10)
	print('\n A Offset=%d B Offset=%d hours=%d\n\n'%(xi,BOffset,zi))
	crlf = ser.read(1)
	if(AorB != 2):
		BOffset = xi; 
	return 0

def EatResponse(DALI):
	ser.write("%s\n"%DALI) # recal
	time.sleep(.5)
	x=ser.read(1)
	while(x != ''):
		x=ser.read(1)
	return


GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM)
GPIO.setup(27,GPIO.IN)
GPIO.setup(22,GPIO.IN)
GPIO.setup(5,GPIO.IN)
GPIO.setup(6,GPIO.IN)


print("\n Calibrate Voltages")

x=ser.read(100)

print('')
ser.write('v\n')  # lets get version number first
x=ser.read()
if x == "" :
	print(' Serial Port not configured \n\n')
	exit()

x=ser.read(2)
hw=0
if x != "" :
	hw=int(x,10)
print('AL-DALI-Hat: HW-sub version: %d'%(hw))

RJ45_P5 = 13

if(hw == 7):
	RJ45_P5 = 26

print(' %d ' %RJ45_P5)

GPIO.setup(RJ45_P5,GPIO.IN)

y=ser.read(2)
print('AL-DALI-Hat: FW version: %s'%(y))
fwver = int(y,10)

hwtype=0
y=ser.read(2)
if y != "\n" :
	hwtype=int(y,10)
	y=ser.read(1)

if hwtype == 2 :
	print('AL-DALI-2I: Isolated no power\nChannels:  2')
elif hwtype == 4 :
	print('AL-DALI-4I: Isolated no power\nChannels:  4')

elif hwtype == 1 :
	print('AL-DALI-Hat: with power v2 \nChannels:   1')

else :
	print('AL-DALI-Hat: zwd model = %d'%hwtype )

if( hw == 3 or hw == 7):
	if(GPIO.input(6) ):
		print(' B1 has power')
	if(GPIO.input(RJ45_P5) ):
		print(' B2 has power')
	if(GPIO.input(27) ):
		print(' C1 has power')
	if(GPIO.input(22) ):
		print(' C2 has power')
	if(GPIO.input(5) ):
		print(' C3 has power')


ser.write("w7\n")  # check the calibration
x=ser.read(1)
volts = 0
Both = 3

while(x != 'W' ):
	print("%s"%x)
	x=ser.read(1)

while 1 :

	if( x == "W" ):
		GetOffset(Both)
		ser.write("p\n") # read power
		x=ser.read(1)

	if(x == ""):

		print("+ => +10, - => -50, n => -2 (=) set to 48v / 51v (S) Status: ")
		if( Both & 1 ):
			print("A"),
		if( Both & 2 ):
			print("B"),
		print(" will be modified")

		Level = raw_input("input command, A, B, +,=,-, Q: ")
		Level = Level.upper()
		if(Level == 'S' or Level == 's' ):
			ser.write("w7\n") # get Offsets

		elif(Level == 'A' ):
			Both = 1

		elif(Level == 'B' ):
			Both = 2

		elif(Level == '='):
			BOffset = 0
			EatResponse("w80") # recal auto 48/51
			EatResponse("w90") # recal auto 48/51
			ser.write("w7\n") # get Offsets

		elif(Level == '+'):
			BOffset = BOffset +10
			if(Both & 1):
				EatResponse("w8%d"%BOffset) # set Offset up
			if(Both & 2):
				EatResponse("w9%d"%BOffset) # set Offset up
			ser.write("w7\n") # read power

		elif(Level == 'n'):
			BOffset = BOffset +2
			if(Both & 1):
				EatResponse("w8%d"%BOffset) # set Offset up
			if(Both & 2):
				EatResponse("w9%d"%BOffset) # set Offset up
			ser.write("w7\n") # read power

		elif(Level == '5'): # correct for 51v
			BOffset = BOffset +300
			if(Both & 1):
				EatResponse("w8%d"%BOffset) # set Offset up
			if(Both & 2):
				EatResponse("w9%d"%BOffset) # set Offset up
			ser.write("w7\n") # read power

		elif(Level == '-'):
			BOffset = BOffset -50
			if(Both & 1):
				EatResponse("w8%d\n"%BOffset) # set Offset down
			if(Both & 2):
				EatResponse("w9%d\n"%BOffset) # set Offset down
			ser.write("w7\n") # read power

		elif(Level == 'Q'):
			exit()

	elif x == 'H' :
		x=ser.read(4)
		print('data H%s '%(x))
		x=ser.read(1)
	elif x == 'N' :
		if expres == 1 :
			print('no response')  
			expres = 0
		x=ser.read(1)
	elif x == 'J' :
		y=ser.read(2)
		y=int(y,16)
		print('                      Answer %02x on %d\n\n'%(y,rbus))
		x=ser.read(1)

	if x == 'X' :
		print('Framing Error')
		x=ser.read(2)
		print('                      Answer %s'%(x))

	if x == 'Z' :
		print('Collision')
		x=ser.read(1)
		print('                      Answer %s'%(x))
	if x == 'P' :
		print('Voltage Levels')
		x=ser.read(3)
		print('                      A = %s'%(x)),
		x=ser.read(3)
		print(' B = %s'%(x))
		x=ser.read(2)

	x=ser.read(1)
