#
#
# program to find Scene members
# scan all scenes
# optionally scan for the members of one group
#


import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=1,
)
serfast = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.2,
)


print('\n      ATX LED Consultants Inc - Read Scenes \n')

ser.write('d\n')  # now check if Power is good
x=ser.read(1)
if x == '' :
	print('  Serial Port Conflict  ')
	exit()
if x == 'D' :
	y=ser.read(2)
	y=int(y,16)
	if y == 0 :
		print('DALI BUS: power is lost')
	if y == 1 :
		print('DALI BUS: power is stuck high')
	if y == 2 :
		print('DALI BUS: power is good')
	if y == 3 :
		print('DALI BUS: power is not yet known')

print(' ')
x=ser.read(10)

if( len(sys.argv) == 2 ):
	scene = int(sys.argv[1])
	count = scene + 1
else :
	scene = 0
	count = 16

text = 'A'

while text != 'q' :

	text = raw_input("Search members in Scene ( 0-15 ) q is Exit, n is next, s is save  : ")
	if text != 'q' :

		if text == 'n' :
			scene = scene+1
			print ' Scan Scene %d'%scene
		elif text == 's' :
			print 'saving in %d'%scene
			ser.write('hFF21\n')  # load DTR
			ncrlf = ser.read(2)
			ser.write('tFF4%x\n'%scene)  # load DTR
			ncrlf = ser.read(2)
		else:
			scene = int(text)

		sa=0

		found = 0

		x=ser.read(1000)
		while sa < 64 :

			msb = 0
			lsb = 0
			ser.write('hC3FF\n')  # clear DTR1
			ncrlf = ser.read(2)

			ser.write('h%02xB%x\n'%(sa*2+1,scene))
			x=ser.read(1)
			if x == 'D' :
				x=ser.read(2)
				print('DALI power up/down %2s' % x)
			if x == 'J' :
				text=ser.read(2)
				response = int(text,16)
				if response < 255 :
					print('\n   Address %2d set by scene to %3d '% (sa, response) ),
					found = 1
				crlf=ser.read(1)
				ser.write('h%02x9C\n'%(sa*2+1)) # check CCT
				x=ser.read(1)
				if x == 'J' :
					text=ser.read(2)
					msb = int(text,16)
					if msb != 255 :
						crlf=ser.read(1)
						ser.write('h%02x98\n'%(sa*2+1)) # check CCT
						x=ser.read(1)
						if x == 'J' :
							text=ser.read(2)
							lsb = int(text,16)
				color = 5000 - (msb*256 + lsb)*13/2
				if(color > 2600 ) :
					found = 1
					if(response == 255):
						print('\n   Address %2d level not set       '% (sa) ),
						print(' Color set to %d '% (color) ),						
					else:
						print(' Color set to %d '% (color) ),

			if x == 'X' :
				type = ser.read(1)
				print('   Collision %d '% (sa) )
			if x == 'H' :
				trash = ser.read(4)
			cr=ser.read(1)
			sa = sa+1
			time.sleep(.05)

		if found == 0 :
			print(' no members ')

		print(' ')

