#
#
# program to reset scenes
# request which short address
# reset one or all
# which scene or all
#

import time
import serial
import sys

ser = serial.Serial(
	port ='/dev/ttyS0',
	baudrate = 19200,
	parity=serial.PARITY_NONE,
	stopbits=serial.STOPBITS_ONE,
	bytesize=serial.EIGHTBITS,
	timeout=.2,
)


print('\n      ATX LED Consultants Inc - Reset Scene\n')

ser.write('d\n')  # now check if Power is good
x=ser.read(1)
if x == 'D' :
	y=ser.read(2)
	y=int(y,16)
	if y == 0 :
		print('DALI BUS: power is lost')
	if y == 1 :
		print('DALI BUS: power is stuck high')
	if y == 2 :
		print('DALI BUS: power is good')
	if y == 3 :
		print('DALI BUS: power is not yet known')
if x == '' :
	print('  Serial Port Conflict  ')
	exit()

print(' ')


while 1 :
	text = raw_input("\nWhich DALI address ( 0-63, 127=all, q=exit ) : ")
	if(text == 'q'):
		exit()
	address = int(text)*2
	text = input("Which scene address ( 0-15, 16=all ) : ")
	scene = int(text)
	x=ser.read(10000)
	found = 0

	if( scene == 16 ):
		scene = 0
		while scene < 16 :
			ser.write('h%02x5%x\n'%(address+1,scene))
			time.sleep(.1)
			ncrlf=ser.read(2)
			scene = scene + 1
	else :
		ser.write('hC301\n')  # DTR1
		ser.write('hA3FF\n')  # DTR
		ser.write('t%02XE7\n'%(address+1))  # Set CCT out of range

		ser.write('t%02x4%x\n'%(address+1,scene))  # Save scene to reset
		ser.write('hC300\n')  # DTR1
		ser.write('t%02XE7\n'%(address+1))  # Reset internal CCT to enable CCT save again

		time.sleep(.1)
		ncrlf=ser.read(20)
		if(address != 254 ):
			ser.write('h%02xB%x\n'%(address+1,scene))
			x=ser.read(1)
			if x == 'J' :
				text=ser.read(2)
				response = int(text,16)
				if response < 255 :
					print('\n   Address %2d set by scene to %3d '% (address/2, response) ),
					found = 1
				ser.write('h%02x9C\n'%(address+1)) # check CCT
				crlf=ser.read(1)
				x=ser.read(1)
				msb=0
				if x == 'J' :
					text=ser.read(2)
					msb = int(text,16)
				crlf=ser.read(1)
				ser.write('h%02x98\n'%(address+1)) # check CCT
				x=ser.read(1)
				if x == 'J' :
					text=ser.read(2)
					lsb = int(text,16)
				color = 5000 - (msb*256 + lsb)*13/2		
				if(color > 2600 ) :
					found = 1
					if(response == 255):
						print('\n   Address %2d level not set       '% (address/2) ),
						print(' Color set to %d '% (color) ),						
					else:
						print(' Color set to %d '% (color) ),

			crlf=ser.read(1)
			if found == 0 :
				print 'Reset Success'


