

# This is an example script for the ATX-LED streaming event API.
# This code waits for messages from the ZWD server, which are triggered
# in the Schedule or Trigger systems. To use this code, set up a scheduled
# event or a trigger, and select 'Send a message to a script' in the Action
# dropdown. You can choose to specify a string of characters to send to
# this script (as specified in the above action). This message will be sent
# to this script (in the form of a UTF-8 encoded string of bytes), and the
# code within main() below can decide what to do based on the message.

# do not create a file or directory "api-events"

import os
import socket

SOCKET_PATH = '/home/pi/atxled/api-events'

def main():

    for message in listen_for_messages():
        # Application logic goes here!
        # You can parse the message and do whatever you want here.
        print('Got a message: %s' % message)

# This generator function waits for messages. You probably don't need to modify it.

def listen_for_messages():

    sock = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)

    try:
        sock.bind(SOCKET_PATH)
        sock.listen(0)

        while True:
            [conn, addr] = sock.accept()
            message = conn.recv(64)
            yield message
            conn.close()

    finally:
        os.unlink(SOCKET_PATH)

if __name__ == '__main__':

    main()
